var alerts = {
	
	render_: function( elapsed_time ) {

		crisis.trigger_crisis();

		var content = helper.content();

		if ( crisis.is_active() ) {

			var overdue = 0;

			var trigger = null;

			var $alerts = '';

			var completed_alerts = content['crisis'][0]['crisis_alert'];

			$( helper.order_alert( content['alert'] ) ).each( function( i ) {

				var dhm = helper.get_dhm( this['alert_minute'] );

				var alert_ = {

					alert_id: this['alert_id'],

					status: helper.alert_status( this['alert_minute'], elapsed_time, $.inArray( this['alert_id'], completed_alerts ) == -1 ? false : true ),

					time: dhm.days + ( dhm.days == 1 ? ' day' : ' days' ) + ', ' + dhm.hours + ( dhm.hours == 1 ? ' hour' : ' hours' ) + ', ' + dhm.minutes + ( dhm.minutes == 1 ? ' min' : ' mins' ),

					icon: helper.alert_icon( this['alert_type'] )

				};

				if ( this['alert_minute'] == elapsed_time ) {

					trigger = alert_;

				}

				$alerts +=	'<li class="' + alert_.status + '" onclick="alerts.trigger( \'' + alert_.alert_id + '\', \'' + alert_.icon + '\' )" >' +

								'<span class="icon ' + alert_.icon + '"></span>' +

								'<div class="on-right text tiny">' + alert_.time + '</div>' +

								'<a href="#" >' +

									'<strong>' + this['alert_name'] + '</strong>' +

									'<small>' + this['alert_details'] + '</small>' +

								'</a>' +

							'</li>';

				if ( alert_.status != 'accept' && alert_.status != 'color' ) {

					overdue++;

				}

			} );

			Lungo.Element.count( '.overdue', overdue );

			if ( trigger != null ) {

				alerts.trigger( trigger.alert_id, trigger.icon );

			}

			$( '#home-crisis-active ul' ).html( $alerts );

		} else {



		}

	},

	trigger: function( alert_id, icon ) {

		var alert_obj = helper.content()['alert'][alert_id];

		variables.alert_id = alert_obj['alert_id'];

		Lungo.Notification.confirm( {

			icon: icon,

			title: alert_obj['alert_name'],

			description: alert_obj['alert_details'] + '<br /><div class="form" ><fieldset><label style="width: 80%; text-align: left; line-height: 2.2em;" >Mark as complete</label><input type="checkbox" checked="checked" id="complete--alert" class="inline" /></fieldset></div>',

			accept: {

				icon: 'checkmark',

				label: 'Okay',

				callback: function() {

					if ( $( '#complete--alert' ).is( ':checked') ) {

						alerts.complete( variables.alert_id );

					} else {

						alerts.incomplete( variables.alert_id );

					}

					switch ( alert_obj['alert_type'] ) {

						case 'contact_team':

								contact.view( alert_obj['alert_meta'], 'team' );

							break;

						case 'contact_internal':

								contact.view( alert_obj['alert_meta'], 'internal' );

							break;

						case 'contact_external':

								contact.view( alert_obj['alert_meta'], 'external' );

							break;

						case 'camera':

								if ( in_device ) {

									camera.trigger();

								} else {

									setTimeout( function() {

										Lungo.Notification.error( 'Not available', 'You cannot take pictures in web version', 'remove', 2 );

									}, 300 );

								}

							break;

					}

				}

			},

			cancel: {

				icon: 'close',

				label: 'Not now', callback: function() {

					if ( $( '#complete--alert' ).not( ':checked') ) {

						alerts.incomplete( variables.alert_id );

					}


				}

			}

		} );

	},

	complete: function( alert_id ) {

		var content = helper.content();

		var crisis_obj = content['crisis'];

		if ( $.inArray( alert_id + '', crisis_obj[0]['crisis_alert'] ) == -1 ) {

			var method = 'insert';

			var data = {

				crisis_id: crisis_obj[0]['crisis_id'],

				alert_id: '' + alert_id + '',

				alert_action: helper.get_date_format(),

				alert_action_unix: helper.get_date_unix(),

			};

			crisis_obj[0]['crisis_alert'].push( '' + alert_id );

			helper.content( content );

			update.update( 'crisis_alert', method, 0, data );

		} else {

			var method = 'update';

			var data = {

				crisis_id: crisis_obj[0]['crisis_id'],

				alert_id: '' + alert_id + '',

				alert_action: helper.get_date_format(),

				alert_action_unix: helper.get_date_unix(),

			};

			crisis_obj[0]['crisis_alert'].push( '' + alert_id );

			helper.content( content );

			update.update( 'crisis_alert', method, 0, data );

		}

	},

	incomplete: function( alert_id ) {

		var content = helper.content();

		var crisis_obj = content['crisis'];

		var method = 'delete';

		var data = {

			crisis_id: crisis_obj[0]['crisis_id'],

			alert_id: '' + alert_id + ''

		};

		var array = crisis_obj[0]['crisis_alert'];

		if ( $.inArray( '' + alert_id, array ) != -1 ) {

			array.splice( array.indexOf( alert_id ), 1 );

			crisis_obj[0]['crisis_alert'] = array;

			helper.content( content );

			update.update( 'crisis_alert', method, alert_id, data );

		}

	},

	elements: {

		menu: '.menu-icon-alerts-incomplete',

		article: '#alerts',

		container: '#alerts-list',

		msg: '#alerts-msg',

		edit: {

			trigger: '#alerts-edit',

			add: '#alerts-edit-add-tmpl',

			form: '#alerts-edit-form',

			id: '#alerts-edit-id',

			name: '#alerts-edit-name',

			details: '#alerts-edit-details',

			category: '#alerts-edit-category',

			type: '#alerts-edit-type',

			day: '#alerts-edit-day',

			hour: '#alerts-edit-hour',

			minute: '#alerts-edit-minute',

			team: '#alerts-edit-team',

			internal: '#alerts-edit-internal',

			external: '#alerts-edit-external',

			team_extra: '#alerts-edit-team-extra',

			internal_extra: '#alerts-edit-internal-extra',

			external_extra: '#alerts-edit-external-extra',

			default_alerts: '#alerts-edit-default'

		},

		delete: '#alerts-delete',

		view: {

			name: '#alerts-view-name',

			details: '#alerts-view-details'

		}

	},

	init: function() {

		var state = Object.keys( helper.content()['alert'] ).length > 1 ? false : true;

		if ( state ) {

			$( alerts.elements.menu ).removeClass( 'hidden' );

			$( alerts.elements.msg ).addClass( 'hidden' );

		} else {

			$( alerts.elements.menu ).addClass( 'hidden' );

			$( alerts.elements.msg ).removeClass( 'hidden' );

		}

		return state;

	},

	// view: function( alert_id, router ) {

	// 	var content = helper.content();

	// 	$( alerts.elements.edit.trigger ).attr( 'onclick', 'alerts.edit( \'' + alert_id + '\' )' );

	// 	$( alerts.elements.delete ).attr( 'onclick', 'alerts.delete( \'' + alert_id + '\' )' );

	// 	$( alerts.elements.view.name ).text( content['alert'][alert_id]['alert_name'] );

	// 	$( alerts.elements.view.details ).html( content['alert'][alert_id]['alert_details'].replace(/\n/g, '<br />') );

	// 	if ( typeof router == 'undefined' || router == true ) {

	// 		Lungo.Router.section( 'alerts-view' );

	// 	}

	// },

	add: function() {

		var content = helper.content();

		$( alerts.elements.edit.add ).removeClass( 'hidden' );

		$( alerts.elements.edit.id ).val( '' );

		$( alerts.elements.edit.name ).val( '' );

		$( alerts.elements.edit.details ).val( '' );

		$( alerts.elements.edit.category ).val( 'Access the risk and severity and response (immediate)' );

		$( alerts.elements.edit.type ).val( 'contact_team' );

		$( alerts.elements.edit.day ).val( 0 );

		$( alerts.elements.edit.hour ).val( 0 );

		$( alerts.elements.edit.minute ).val( 0 );

		//

		$( alerts.elements.edit.team_extra ).removeClass( 'hidden' );

		$( alerts.elements.edit.internal_extra ).addClass( 'hidden' );

		$( alerts.elements.edit.external_extra ).addClass( 'hidden' );

		Lungo.Router.section( 'alerts-edit' );

	},

	render_default_alerts: function() {

		var $html = '';

		var alert = helper.order_alert( helper.content()['alert']['tmp'], true );

		for ( var key in alert ) {

			$html += 	'<li class="anchor contrast alert-category">' + key + '</li>' + 

							'<ul>';

				$( alert[key].data ).each( function() {

					$html +=	'<li onclick="alerts.edit_default( \'' + this['alert_id'] + '\' )" >' +

									'<a href="#" >' + this['alert_name'] + '</a>' +

								'</li>';

				} );

			$html +=		'</ul>' +

						'</li>';

		}

		$( alerts.elements.edit.default_alerts ).html( $html );

	},
	
	edit_default: function( alert_id ) {

		var alert_ = helper.content()['alert']['tmp'][alert_id];

		var time = helper.get_dhm( alert_['alert_minute'] );

		$( alerts.elements.edit.add ).removeClass( 'hidden' );

		$( alerts.elements.edit.id ).val( '' );

		$( alerts.elements.edit.name ).val( alert_['alert_name'] );

		$( alerts.elements.edit.details ).val( alert_['alert_details'] );

		$( alerts.elements.edit.category ).val( alert_['alert_category'] );

		$( alerts.elements.edit.type ).val( alert_['alert_type'] );

		$( alerts.elements.edit.day ).val( time.days );

		$( alerts.elements.edit.hour ).val( time.hours );

		$( alerts.elements.edit.minute ).val( time.minutes );

		if ( alert_['alert_type'] == 'contact_team' ) {

			$( alerts.elements.edit.team_extra ).removeClass( 'hidden' );

		} else {

			$( alerts.elements.edit.team_extra ).addClass( 'hidden' );

		}

		if ( alert_['alert_type'] == 'contact_internal' ) {

			$( alerts.elements.edit.internal_extra ).removeClass( 'hidden' );

		} else {

			$( alerts.elements.edit.internal_extra ).addClass( 'hidden' );

		}

		if ( alert_['alert_type'] == 'contact_external' ) {

			$( alerts.elements.edit.external_extra ).removeClass( 'hidden' );

		} else {

			$( alerts.elements.edit.external_extra ).addClass( 'hidden' );

		}

		Lungo.Router.section( 'alerts-edit' );

	},
	
	edit: function( alert_id ) {

		var content = helper.content();

		$( alerts.elements.delete ).attr( 'onclick', 'alerts.delete( \'' + alert_id + '\' )' );

		var time = helper.get_dhm( content['alert'][alert_id]['alert_minute'] );

		$( alerts.elements.edit.add ).addClass( 'hidden' );

		$( alerts.elements.edit.id ).val( alert_id );

		$( alerts.elements.edit.name ).val( content['alert'][alert_id]['alert_name'] );

		$( alerts.elements.edit.details ).val( content['alert'][alert_id]['alert_details'] );

		$( alerts.elements.edit.category ).val( content['alert'][alert_id]['alert_category'] );

		$( alerts.elements.edit.type ).val( content['alert'][alert_id]['alert_type'] );

		$( alerts.elements.edit.day ).val( time.days );

		$( alerts.elements.edit.hour ).val( time.hours );

		$( alerts.elements.edit.minute ).val( time.minutes );

		if ( content['alert'][alert_id]['alert_type'] == 'contact_team' ) {

			$( alerts.elements.edit.team_extra ).removeClass( 'hidden' );

		} else {

			$( alerts.elements.edit.team_extra ).addClass( 'hidden' );

		}

		if ( content['alert'][alert_id]['alert_type'] == 'contact_internal' ) {

			$( alerts.elements.edit.internal_extra ).removeClass( 'hidden' );

		} else {

			$( alerts.elements.edit.internal_extra ).addClass( 'hidden' );

		}

		if ( content['alert'][alert_id]['alert_type'] == 'contact_external' ) {

			$( alerts.elements.edit.external_extra ).removeClass( 'hidden' );

		} else {

			$( alerts.elements.edit.external_extra ).addClass( 'hidden' );

		}

		Lungo.Router.section( 'alerts-edit' );

	},

	save: function() {

		var content = helper.content();

		var data = {

			alert_id: $( alerts.elements.edit.id ).val() == '' ? helper.generate_id() : $( alerts.elements.edit.id ).val(),

			alert_name: $( alerts.elements.edit.name ).val() == '' ? 'Untitled' : $( alerts.elements.edit.name ).val(),

			alert_type: $( alerts.elements.edit.type ).val(),

			alert_meta: '',

			alert_minute: helper.get_minutes( $( alerts.elements.edit.day ).val(), $( alerts.elements.edit.hour ).val(), $( alerts.elements.edit.minute ).val() ),

			alert_details: $( alerts.elements.edit.details ).val(),

			alert_category: $( alerts.elements.edit.category ).val(),

			alert_order: $( alerts.elements.edit.category + ' option:selected' ).data( 'order' )

		};

		var method = typeof content['alert'][data.alert_id] == 'undefined' ? 'insert' : 'update';

		switch( data.alert_type ) {

			case 'contact_team':

					data['alert_meta'] = $( alerts.elements.edit.team ).val();

				break;

			case 'contact_internal':

					data['alert_meta'] = $( alerts.elements.edit.internal ).val();

				break;

			case 'contact_external':

					data['alert_meta'] = $( alerts.elements.edit.external ).val();

				break;

		};

		content['alert'][data.alert_id] = data;

		helper.content( content );

		update.update( 'alert', method, data.alert_id, data );

		alerts.render();

		Lungo.Router.back();

		// alerts.view( data.alert_id, false );

	},
	
	delete: function( alert_id ) {

		var content = helper.content();

		delete content['alert'][alert_id];

		helper.content( content );

		update.update( 'alert', 'delete', alert_id, {} );

		alerts.render();

		Lungo.Router.back();

	},

	render: function() {

		alerts.init();

		var content = helper.content();

		var $alert = '';

		var alerts_ = helper.order_alert( helper.content()['alert'], true );

		for ( var key in alerts_ ) {

			$alert += 	'<li class="anchor contrast alert-category">' + key + '</li>' + 

							'<ul>';

				$( alerts_[key].data ).each( function() {

					$alert +=		'<li class="arrow filter-alert" onclick="alerts.edit(\'' + this['alert_id'] + '\')" >' +

										'<a href="#" >' +

											'<strong>' + this['alert_name'] + '</strong>' +

											'<small>' + this['alert_details'] + '</small>' +

										'</a>' +

									'</li>';

				} );

			$alert += 		'</ul>' + 

						'</li>';

		}

		$( alerts.elements.container ).html( $alert );

	}

};