var asset = {

	elements: {

		menu: '.menu-icon-asset-incomplete',

		count: '.menu-icon-asset-count',

		article: '#asset',

		container: '#asset-list',

		msg: '#asset-msg',

		edit: {

			trigger: '#asset-edit',

			form: '#asset-edit-form',

			id: '#asset-edit-id',

			name: '#asset-edit-name',

			details: '#asset-edit-details',

			category: '#asset-edit-category',

			state: '#asset-edit-state'

		},

		delete: '#asset-delete',

		view: {

			id: '#asset-view-id',

			name: '#asset-view-name',

			details: '#asset-view-details',

			state: '#asset-view-state'

		}

	},

	init: function() {

		var content = helper.content();

		var state = Object.keys( content['asset'] ).length > 1 ? false : true;

		$( asset.elements.count ).addClass( 'hidden' ).text( '' );

		if ( state ) {

			$( asset.elements.menu ).removeClass( 'hidden' );

			$( asset.elements.msg ).addClass( 'hidden' );

		} else {

			var count = helper.get_incomplete_count( content['asset'], 'asset_state' );

			$( asset.elements.menu ).addClass( 'hidden' );

			if ( count === 0 ) {

				$( asset.elements.count ).addClass( 'hidden' ).text( count );

			} else {

				$( asset.elements.count ).removeClass( 'hidden' ).text( count );

			}

			$( asset.elements.msg ).removeClass( 'hidden' );

			state = count;

		}

		return state;

	},

	view: function( asset_id, router ) {

		var content = helper.content();

		$( asset.elements.edit.trigger ).attr( 'onclick', 'asset.edit( \'' + asset_id + '\' )' );

		$( asset.elements.delete ).attr( 'onclick', 'asset.delete( \'' + asset_id + '\' )' );

		$( asset.elements.view.name ).text( content['asset'][asset_id]['asset_name'] );

		$( asset.elements.view.details ).html( content['asset'][asset_id]['asset_details'].replace(/\n/g, '<br />') );

		$( asset.elements.view.id ).val( asset_id );

		if ( content['asset'][asset_id]['asset_state'] == 'false' ) {

			$( asset.elements.view.state ).removeAttr( 'checked' );

		} else {

			$( asset.elements.view.state ).attr( 'checked', 'checked' );

		}

		if ( typeof router == 'undefined' || router == true ) {

			Lungo.Router.section( 'asset-view' );

		}

	},

	add: function() {

		var content = helper.content();

		$( asset.elements.edit.id ).val( '' );

		$( asset.elements.edit.name ).val( '' );

		$( asset.elements.edit.details ).val( '' );

		$( asset.elements.edit.category ).val( 'Payments' );

		Lungo.Router.section( 'asset-edit' );

	},
	
	edit: function( asset_id ) {

		var content = helper.content();

		$( asset.elements.edit.id ).val( asset_id );

		$( asset.elements.edit.name ).val( content['asset'][asset_id]['asset_name'] );

		$( asset.elements.edit.details ).val( content['asset'][asset_id]['asset_details'] );

		$( asset.elements.edit.category ).val( content['asset'][asset_id]['asset_category'] );

		Lungo.Router.section( 'asset-edit' );

	},

	save: function() {

		var content = helper.content();

		var data = {

			asset_id: $( asset.elements.edit.id ).val() == '' ? helper.generate_id() : $( asset.elements.edit.id ).val(),

			asset_name: $( asset.elements.edit.name ).val() == '' ? 'Untitled' : $( asset.elements.edit.name ).val(),

			asset_details: $( asset.elements.edit.details ).val(),

			asset_category: $( asset.elements.edit.category ).val(),

			asset_state: $( asset.elements.edit.state ).is( ':checked' ) ? 'true' : 'false'

		};

		var method = typeof content['asset'][data.asset_id] == 'undefined' ? 'insert' : 'update';

		content['asset'][data.asset_id] = data;

		helper.content( content );

		update.update( 'asset', method, data.asset_id, data );

		asset.render();

		Lungo.Router.back();

		asset.view( data.asset_id, false );

	},

	save_state: function() {

		var method = 'update';

		var content = helper.content();

		var data = {

			asset_id: $( asset.elements.view.id ).val(),

			asset_state: $( asset.elements.view.state ).is( ':checked' ) ? 'true' : 'false'

		};

		content['asset'][data.asset_id]['asset_state'] = data.asset_state;

		helper.content( content );

		update.update( 'asset', method, data.asset_id, data );

		asset.render();

		Lungo.Router.back();

		asset.view( data.asset_id, false );

	},
	
	delete: function( asset_id ) {

		var content = helper.content();

		delete content['asset'][asset_id];

		helper.content( content );

		update.update( 'asset', 'delete', asset_id, {} );

		asset.render();

		Lungo.Router.back();

	},

	render: function() {

		asset.init();

		var content = helper.content();

		var $asset = '';

		var assets = helper.order_asset( helper.content()['asset'], true );

		for ( var key in assets ) {

			$asset += 	'<li class="anchor contrast asset-category">' + key + '</li>' + 

							'<ul>';

				$( assets[key].data ).each( function() {

					$asset +=		'<li class="arrow filter-asset' + ( this['asset_state'] == 'false' ? ' cancel' : '' ) + '" onclick="asset.view(\'' + this['asset_id'] + '\')" >' +

										'<a href="#" >' +

											'<strong>' + this['asset_name'] + '</strong>' +

											'<small>' + this['asset_details'] + '</small>' +

										'</a>' +

									'</li>';

				} );

			$asset += 		'</ul>' + 

						'</li>';

		}

		$( asset.elements.container ).html( $asset );

	}

};