var camera = {

	data: {},

	save_picture: function( file_entry ) {

		setTimeout( function() {

			Lungo.Notification.confirm( {

				icon: 'question-sign',

				title: 'Please include a short description to help you identify this image',

				description: '<div class="form"><fieldset><input type="text" placeholder="Description" id="image-desc" /></fieldset></div>',

				accept: {

					label: 'Save',

					icon: 'close',

					callback: function() {

						helper.keyboard_reset( function() {

							file_entry.file( function( file ) {

								var reader = new FileReader();

								reader.onloadend = function( evt ) {

									var content = helper.content();

									var crisis_obj = content['crisis'];

									var method = 'insert';

									navigator.geolocation.getCurrentPosition( function( position ) {

										var data = {

											image_id: helper.generate_id(),

											crisis_id: crisis_obj[0]['crisis_id'],

											image_description: $( '#image-desc' ).val() == '' ? 'Untitled' : $( '#image-desc' ).val(),

											image_blob: evt.target.result,

											image_capture: helper.get_date_format(),

											image_capture_unix: helper.get_date_unix(),

											image_capture_lat: position.coords.latitude,

											image_capture_lng: position.coords.longitude

										};

										update.update( 'crisis_image', method, data.image_id, data );

									}, function( position ) {

										var data = {

											image_id: helper.generate_id(),

											crisis_id: crisis_obj[0]['crisis_id'],

											image_description: $( '#image-desc' ).val() == '' ? 'Untitled' : $( '#image-desc' ).val(),

											image_blob: evt.target.result,

											image_capture: helper.get_date_format(),

											image_capture_unix: helper.get_date_unix(),

											image_capture_lat: 0,

											image_capture_lng: 0

										};

										update.update( 'crisis_image', method, data.image_id, data );

									} );

								};

								reader.readAsDataURL( file );

							} );

						} );

					}

				},

				cancel: {

					icon: 'close',

					label: 'Remove image',

					callback: function() {

						Lungo.Notification.hide();

					}

				}

			} );

		}, 300 );

	},

	trigger: function() {

		navigator.device.capture.captureImage( camera.capture, function() {}, {

			limit: 1

		} );

	},

	capture: function( image ) {

		var image = image[0];

		window.resolveLocalFileSystemURI( ( image.fullPath.indexOf('file://') != -1 ? image.fullPath : 'file://' + image.fullPath ), function( file_entry ) {

			camera.save_picture( file_entry );

		}, function() { } );

	},

	pack: {

		trigger: function() {

			if ( in_device ) {

				navigator.camera.getPicture( camera.pack.capture, function( error ) {

					alert( error );

				}, {

					destinationType: Camera.DestinationType.FILE_URI,

					correctOrientation: true,

					saveToPhotoAlbum: true

				} );

			} else {

				Lungo.Notification.error( 'Not available', 'You cannot take pictures in web version', 'remove', 2 );

			}

		},

		capture: function( image ) {

			window.resolveLocalFileSystemURI( ( image.indexOf('file://') != -1 ? image : 'file://' + image ), function( file_entry ) {

				// var directory = image.indexOf( 'file:///' ) != -1 ? 'DCIM/Camera' : 'photos';

				variables.fs.root.getDirectory( variables.file_dir, {

					create: false,

					exclusive: false

				}, function( dir ) {

					file_entry.moveTo( dir, helper.generate_id() + '.jpg', camera.pack.save_picture, function() {

						alert( 'error 03' );

					} );

				}, function() {

					alert( 'error 02' );

				} );

			}, function() {

				alert( 'error 01' );

			} );

		},

		save_picture: function( file_entry ) {

			var content = helper.content();

			var data = {

				path: file_entry.fullPath.replace( variables.fs.root.fullPath + '/', '' ),

				name: helper.get_date_format()

			};

			var active_pack = content['pack'][ $( pack.elements.view.id ).val() ];

			var documents = active_pack['pack_documents'] == '' ? [] : $.parseJSON( active_pack['pack_documents'] );

			documents.push( data );

			active_pack['pack_documents'] = JSON.stringify( documents );

			helper.content( content );

			update.update( 'pack', 'update', active_pack['pack_id'], {

				pack_documents: active_pack['pack_documents']

			} );

			setTimeout( function() {

				pack.view( $( pack.elements.view.id ).val(), true );

			}, 1000 );

		}

	}

};