var contact = {

	elements: {

		menu_team_incomplete: '.menu-icon-team-incomplete',

		menu_internal_incomplete: '.menu-icon-internal-incomplete',

		menu_external_incomplete: '.menu-icon-external-incomplete',

		menu_contact_incomplete: '.menu-icon-contact-incomplete',

		article: '#contact',

		container: '#contact-list',

		msg: '#contact-msg',

		edit: {

			device_contacts: '#contact-edit-device-side-pre',

			device_contacts_pre: '#contact-edit-team-pre',

			device_contacts_internal_pre: '#contact-edit-internal-pre',

			default_contacts: '#contact-edit-default',

			default_contacts_pre: '#contact-edit-default-pre',

			hide_template: '.contact-edit-hide-template',

			hide_type: '.contact-edit-hide-type',

			tmpl: '#contact-edit-add-tmpl',

			trigger: '#contact-edit',

			form: '#contact-edit-form',

			id: '#contact-edit-id',

			device_id: '#contact-edit-device-id',

			type: '#contact-edit-type',

			name: '#contact-edit-name',

			details: '#contact-edit-details',

			email: '#contact-edit-email',

			number_work: '#contact-edit-work',

			number_mobile: '#contact-edit-mobile',

			number_home: '#contact-edit-home',

			roles: '#contact-edit-roles',

			responsibilities: '#contact-edit-responsibilities',

			category: '#contact-edit-category',

			team: '#contact-edit-team-extra',

			external: '#contact-edit-external-extra'

		},

		delete: '#contact-delete',

		view: {

			id: '#contact-view-id',

			name: '#contact-view-name',

			details: '#contact-view-details',

			list: '#contact-view-list',

			roles: '#contact-view-roles',

			responsibilities: '#contact-view-responsibilities'

		},

		team: {

			container: '#contact-team-list',

		},

		internal: {

			container: '#contact-internal-list',

		},

		external: {

			container: '#contact-external-list',

		}

	},

	add_action: function( type, target ) {

		$( '.' + target ).attr( 'onclick', 'contact.add( \'' + type + '\' );' );

	},

	init: function() {

		helper.ready_progress();

		var state_team = Object.keys( helper.content()['contact']['team'] ).length > 1 ? false : true;

		var state_internal = Object.keys( helper.content()['contact']['internal'] ).length > 1 ? false : true;

		var state_external = Object.keys( helper.content()['contact']['external'] ).length > 1 ? false : true;

		var state_contact =  state_internal || state_external ? true : false;

		if ( state_team ) {

			$( contact.elements.menu_team_incomplete ).removeClass( 'hidden' );

		} else {

			$( contact.elements.menu_team_incomplete ).addClass( 'hidden' );

		}

		if ( state_internal ) {

			$( contact.elements.menu_internal_incomplete ).removeClass( 'hidden' );

		} else {

			$( contact.elements.menu_internal_incomplete ).addClass( 'hidden' );

		}

		if ( state_external ) {

			$( contact.elements.menu_external_incomplete ).removeClass( 'hidden' );

		} else {

			$( contact.elements.menu_external_incomplete ).addClass( 'hidden' );

		}

		if ( state_contact ) {

			$( contact.elements.menu_contact_incomplete ).removeClass( 'hidden' );

		} else {

			$( contact.elements.menu_contact_incomplete ).addClass( 'hidden' );

		}

	},

	view: function( contact_id, contact_type, router ) {

		var content = helper.content();

		var contact_ = content['contact'][contact_type][contact_id];

		if ( typeof contact_ != 'undefined' ) {

			$( contact.elements.edit.trigger ).attr( 'onclick', 'contact.edit( \'' + contact_id + '\', \'' + contact_type + '\' )' );

			$( contact.elements.delete ).attr( 'onclick', 'contact.delete( \'' + contact_id + '\', \'' + contact_type + '\' )' );

			$( contact.elements.view.id ).val( contact_['contact_id'] );

			$( contact.elements.view.name ).text( contact_['contact_name'] );

			$( contact.elements.view.details ).html( content['contact'][contact_type][contact_id]['contact_details'].replace(/\n/g, '<br />') );

			var $contact = '';

			// if ( contact_['contact_email'] != '' || contact_['contact_phone_work'] != '' || contact_['contact_phone_mobile'] != '' || contact_['contact_phone_home'] != '' ) {

				if ( contact_['contact_email'] != '' ) {

					$contact +=		'<li>' +

										'<a href="mailto:' + contact_['contact_email'] + '" >' +

											'<strong>Email address</strong>' +

											'<small>' + contact_['contact_email'] + '</small>' +

										'</a>' +

									'</li>';

				}

				if ( contact_['contact_number_work'] != '' ) {

					$contact +=		'<li>' +

										'<a href="tel:' + contact_['contact_number_work'] + '" >' +

											'<strong>Work number</strong>' +

											'<small>' + contact_['contact_number_work'] + '</small>' +

										'</a>' +

									'</li>';

				}

				if ( contact_['contact_number_mobile'] != '' ) {

					$contact +=		'<li>' +

										'<a href="tel:' + contact_['contact_number_mobile'] + '" >' +

											'<strong>Mobile number</strong>' +

											'<small>' + contact_['contact_number_mobile'] + '</small>' +

										'</a>' +

									'</li>';

				}

				if ( contact_['contact_number_home'] != '' ) {

					$contact +=		'<li>' +

										'<a href="tel:' + contact_['contact_number_home'] + '" >' +

											'<strong>Home number</strong>' +

											'<small>' + contact_['contact_number_home'] + '</small>' +

										'</a>' +

									'</li>';

				}

				if ( contact_['contact_type'] == 'team' ) {

					$( contact.elements.view.roles ).val( contact_['contact_roles'] );

					$( contact.elements.view.responsibilities ).val( contact_['contact_responsibilities'] );

					contact.render_roles_view();

					contact.render_responsibilities_view();

					$( '#contact-view-team-extra' ).removeClass( 'hidden' );

				} else {

					$( '#contact-view-team-extra' ).addClass( 'hidden' );

				}

				// if ( contact_['contact_type'] != 'team' ) {

				// 	$contact += '<li data-view-aside="contact-view-roles-list" class="contrast anchor" style="margin-bottom: 0;">' +

				// 					'<span class="on-right in-text"></span>' +

				// 					'<strong style="line-height: 20px; font-size: 18px;">Roles</strong>' +

				// 				'</li>';

				// 	if ( contact_['contact_roles'] != '' && contact_['contact_type'] == 'team' ) {

				// 		$( contact_['contact_roles'].split( ',' ) ).each( function() {

				// 			$contact +=	'<li style="margin-bottom: 0;" >' + 

				// 							'<label for="roles-view-' + this + '" href="#" class="on-right"><span class="icon remove"></span></label>' +

				// 							'<strong>' + this + '</strong>' +

				// 						'</li>';

				// 		} );

				// 	}

				// 	$contact = '<li data-view-aside="contact-view-responsibilities-list" class="contrast anchor" style="margin-bottom: 0;">' +

				// 					'<span class="on-right in-text"></span>' +

				// 					'<strong style="line-height: 20px; font-size: 18px;">Responsibilities</strong>' +

				// 				'</li>';

				// 	if ( contact_['contact_responsibilities'] != '' && contact_['contact_type'] == 'team' ) {

				// 		$( contact_['contact_responsibilities'].split( ',' ) ).each( function() {

				// 			$contact +=	'<li style="margin-bottom: 0;" >' + 

				// 							'<label for="responsibilities-view-' + this + '" href="#" class="on-right"><span class="icon remove"></span></label>' +

				// 							'<strong>' + this + '</strong>' +

				// 						'</li>';


				// 		} );

				// 	}

				// }

			$( contact.elements.view.list ).html( $contact );

			// }

			if ( typeof router == 'undefined' || router == true ) {

				Lungo.Router.section( 'contact-view' );

			}

		} else {

			setTimeout( function() {

				Lungo.Notification.error( 'Could not find contact', 'Redirecting you to contact list', 'cancel', 2, function() {

					Lungo.Router.article( 'prevent', 'contact' );

					Lungo.Notification.hide();

				} );

			}, 300 );

		}

	},

	add: function( type ) {

		var type = typeof type == 'undefined' ? 'team' : type;

		var content = helper.content();

		$( contact.elements.edit.tmpl ).removeClass( 'hidden' );

		$( contact.elements.edit.id ).val( '' );

		$( contact.elements.edit.device_id ).val( '' );

		$( contact.elements.edit.type ).val( type ).hide();

		$( contact.elements.edit.hide_type ).hide();

		if ( type == 'team' || type == 'internal' ) {

			$( contact.elements.edit.hide_template ).addClass( 'hidden' );

		} else {

			$( contact.elements.edit.hide_template ).removeClass( 'hidden' ).show();

		}

		if ( type == 'team' ) {

			$( contact.elements.edit.team ).removeClass( 'hidden' );

		} else {

			$( contact.elements.edit.team ).addClass( 'hidden' );

		}

		if ( type == 'external' ) {

			$( contact.elements.edit.external ).removeClass( 'hidden' );

		} else {

			$( contact.elements.edit.external ).addClass( 'hidden' );

		}

		$( contact.elements.edit.name ).val( '' );

		$( contact.elements.edit.details ).val( '' );

		$( contact.elements.edit.email ).val( '' );

		$( contact.elements.edit.number_work ).val( '' );

		$( contact.elements.edit.number_mobile ).val( '' );

		$( contact.elements.edit.number_home ).val( '' );

		$( contact.elements.edit.roles ).val( '' );

		$( contact.elements.edit.responsibilities ).val( '' );

		$( contact.elements.edit.category ).val( 'Access Points' );

		contact.render_roles();

		contact.render_responsibilities();

		Lungo.Router.section( 'contact-edit' );

	},
	
	edit: function( contact_id, contact_type ) {

		var content = helper.content();

		var contact_ = content['contact'][contact_type][contact_id];

		if ( typeof contact_ != 'undefined' ) {

			$( contact.elements.edit.tmpl ).addClass( 'hidden' );

			$( contact.elements.edit.id ).val( contact_id );

			$( contact.elements.edit.device_id ).val( contact_['device_id'] );

			$( contact.elements.edit.type ).val( contact_type ).show();

			$( contact.elements.edit.hide_type ).show();

			$( contact.elements.edit.hide_template ).show();

			$( contact.elements.edit.name ).val( contact_['contact_name'] );

			$( contact.elements.edit.details ).val( contact_['contact_details'] );

			$( contact.elements.edit.email ).val( contact_['contact_email'] );

			$( contact.elements.edit.number_work ).val( contact_['contact_number_work'] );

			$( contact.elements.edit.number_mobile ).val( contact_['contact_number_mobile'] );

			$( contact.elements.edit.number_home ).val( contact_['contact_number_home'] );

			$( contact.elements.edit.roles ).val( contact_['contact_roles'] );

			$( contact.elements.edit.responsibilities ).val( contact_['contact_responsibilities'] );

			$( contact.elements.edit.category ).val( contact_type == 'external' ? contact_['contact_category'] : 'Access Points' );

			if ( contact_type == 'team' || contact_type == 'internal' ) {

				$( contact.elements.edit.hide_template ).addClass( 'hidden' );

			} else {

				$( contact.elements.edit.hide_template ).removeClass( 'hidden' );

			}

			if ( contact_type == 'team' ) {

				$( contact.elements.edit.team ).removeClass( 'hidden' );

			} else {

				$( contact.elements.edit.team ).addClass( 'hidden' );

			}

			if ( contact_type == 'external' ) {

				$( contact.elements.edit.external ).removeClass( 'hidden' );

			} else {

				$( contact.elements.edit.external ).addClass( 'hidden' );

			}

			contact.render_roles();

			contact.render_responsibilities();

			Lungo.Router.section( 'contact-edit' );

		} else {

			Lungo.Notification.error( 'Could not find contact', 'Redirecting you to contact list', 'cancel', 2, function() {

				Lungo.Router.section( 'contact-view' );

			} );

		}

	},

	save: function() {

		var method = 'update';

		var nc = $( contact.elements.edit.id ).val() != '' ? false : true;

		var data = {

			contact_id: nc ? helper.generate_id() : $( contact.elements.edit.id ).val(),

			device_id: $( contact.elements.edit.device_id ).val(),

			contact_type: $( contact.elements.edit.type ).val(),

			contact_name: $( contact.elements.edit.name ).val() == '' ? 'Untitled' : $( contact.elements.edit.name ).val(),

			contact_details: $( contact.elements.edit.details ).val(),

			contact_email: $( contact.elements.edit.email ).val(),

			contact_number_work: $( contact.elements.edit.number_work ).val(),

			contact_number_mobile: $( contact.elements.edit.number_mobile ).val(),

			contact_number_home: $( contact.elements.edit.number_home ).val(),

			contact_roles: '',

			contact_responsibilities: '',

			contact_category: ''

		};

		if ( data.contact_type == 'team' ) {

			data['contact_roles'] = $( contact.elements.edit.roles ).val();

			data['contact_responsibilities'] = $( contact.elements.edit.responsibilities ).val();

		}

		if ( data.contact_type == 'external' ) {

			data['contact_category'] = $( contact.elements.edit.category ).val();

		}

		var content = helper.content();

		var contact_type;

		switch( data.contact_type ) {

			case 'team':

					contact_type = ['internal','external'];

				break;

			case 'internal':

					contact_type = ['team','external'];

				break;

			case 'external':

					contact_type = ['internal','team'];

				break;

		}

		if ( typeof content['contact'][data.contact_type][data.contact_id] == 'undefined' ) {

			method = 'insert';

		}

		$( contact_type ).each( function() {

			if ( typeof content['contact'][this][data.contact_id] != 'undefined' ) {

				contact.delete( data.contact_id, this );

			}

		} );

		content['contact'][data.contact_type][data.contact_id] = data;

		helper.content( content );

		update.update( 'contact', method, data.contact_id, data );

		contact.render();

		contact.render_default_contacts();

		contact.render_device_contacts();

		Lungo.Router.back();

		contact.view( data.contact_id, data.contact_type, false );

	},

	save_view: function() {

		var contact_id = $( contact.elements.view.id ).val();

		var data = {

			contact_roles: $( contact.elements.view.roles ).val(),

			contact_responsibilities: $( contact.elements.view.responsibilities ).val()

		};

		var content = helper.content();

		content['contact']['team'][contact_id]['contact_roles'] = data.contact_roles;

		content['contact']['team'][contact_id]['contact_responsibilities'] = data.contact_responsibilities;

		helper.content( content );

		update.update( 'contact', 'update', contact_id, data );

		contact.render();

		contact.render_default_contacts();

		contact.render_device_contacts();

		Lungo.Router.back();

	},
	
	delete: function( contact_id, contact_type ) {

		var content = helper.content();

		delete content['contact'][contact_type][contact_id];

		helper.content( content );

		update.update( 'contact', 'delete', contact_id, {} );

		contact.render();

		contact.render_default_contacts();

		contact.render_device_contacts();

		Lungo.Router.back();

	},

	render: function() {

		contact.init();

		var content = helper.content();

		// Team

		var $team = '';

		var $team_select = '';

		var team = helper.order_contact( helper.content()['contact']['team'] );

		$( team ).each( function() {

			$team +=	'<li class="arrow filter-team" onclick="contact.view( \'' + this['contact_id'] + '\', \'team\' );" >' +

							'<a href="#" >' +

								'<strong>' + this['contact_name'] + '</strong>' +

								'<small>' + this['contact_details'] + '</small>' +

							'</a>' +

						'</li>';

			$team_select +=	'<option value="' + this['contact_id'] + '" >' + this['contact_name'] + '</option>';

		} );

		$( contact.elements.team.container ).html( $team );

		$( alerts.elements.edit.team ).html( $team_select == '' ? '<option value="0" >No contacts found</option>' : $team_select );

		// Internal

		var $internal = '';

		var $internal_select = '';

		var internal = helper.order_contact( helper.content()['contact']['internal'] );

		$( internal ).each( function() {

			$internal +=	'<li class="arrow filter-internal" onclick="contact.view( \'' + this['contact_id'] + '\', \'internal\' );" >' +

								'<a href="#" >' +

									'<strong>' + this['contact_name'] + '</strong>' +

									'<small>' + this['contact_details'] + '</small>' +

								'</a>' +

							'</li>';

			$internal_select +=	'<option value="' + this['contact_id'] + '" >' + this['contact_name'] + '</option>';

		} );

		$( contact.elements.internal.container ).html( $internal );

		$( alerts.elements.edit.internal ).html( $internal_select == '' ? '<option value="0" >No contacts found</option>' : $internal_select );

		// External

		var $external = '';

		var $external_select = '';

		var external = helper.order_contact( helper.content()['contact']['external'], true );

		for ( var key in external ) {

			$external += 	'<li class="anchor contrast external-category">' + key + '</li>' + 

								'<ul>';

			$external_select += '<optgroup label="' + key + '">';

				$( external[key].data ).each( function() {

					$external +=	'<li class="arrow filter-external" onclick="contact.view( \'' + this['contact_id'] + '\', \'external\' );" >' +

										'<a href="#" >' +

											'<strong>' + this['contact_name'] + '</strong>' +

											'<small>' + this['contact_details'] + '</small>' +

										'</a>' +

									'</li>';

					$external_select +=	'<option value="' + this['contact_id'] + '" >' + this['contact_name'] + '</option>';

				} );

			$external += 		'</ul>' + 

							'</li>';

			$external_select += '</optgroup>';

		}

		$( contact.elements.external.container ).html( $external );

		$( alerts.elements.edit.external ).html( $external_select == '' ? '<option value="0" >No contacts found</option>' : $external_select );

	},

	search_device_contacts: function( elem ) {

		var $elem = $( elem );

		var val = $elem.val();

		$( '#contact-edit-device-team-pre, #contact-edit-device-internal-pre, #contact-edit-device-side-pre' ).empty();

		$( 'input[data-elem="contact-edit-device-side-pre"], input[data-elem="contact-edit-device-team-pre"], input[data-elem="contact-edit-device-internal-pre"]' ).val( '' );

		$elem.val( val );

		var $container = $( '#' + $elem.attr( 'data-elem' ) );

		var type = $elem.attr( 'data-type' );

		var content = helper.content();

		switch ( type ) {

			case 'team':

					var contacts_ = helper.order_contact( content['contact']['team'] );

				break;

			case 'internal':

					var contacts_ = helper.order_contact( content['contact']['internal'] );

				break;

		}

		if ( in_device ) {

			if ( val.length >= 3 ) {

				$container.html( '<li class="anchor contrast" ></li><li><a class="searching" href="javascript:;" >Searching...</a></li>' );

				var options = new ContactFindOptions();

					options.filter = val;

					options.multiple = true;

				navigator.contacts.find( ['name', 'phoneNumbers', 'emails'], function( contacts ) {

					variables.tmp = {

						device_contacts: []

					};

					$( contacts ).each( function() {

						var contact_obj = this;

						if ( contact_obj.name.familyName != undefined && contact_obj.name.givenName != undefined ) {

							var this_contact = {

								contact_id: '',

								device_id: contact_obj.id,

								contact_type: 'team',

								contact_name: contact_obj.name.givenName + ' ' + contact_obj.name.familyName,

								contact_details: '',

								contact_email: contact_obj.emails != null ? contact_obj.emails[0].value : '',

								contact_number_work: '',

								contact_number_mobile: '',

								contact_number_home: '',

								contact_roles: '',

								contact_responsibilities: ''

							};

							if ( contact_obj.phoneNumbers != null ) {

								$( contact_obj.phoneNumbers ).each( function() {

									if ( this.type == 'mobile' ) {

										this_contact.contact_number_mobile = this.value;

									} else if ( this.type == 'home' ) {

										this_contact.contact_number_home = this.value;

									} else if ( this.type == 'work' ) {

										this_contact.contact_number_work = this.value;

									}

								} );

							}

							variables.tmp.device_contacts.push( this_contact );

						}

					} );

					variables.tmp.device_contacts = Lungo.Core.orderByProperty( variables.tmp.device_contacts, 'contact_name', 'asc' );

					if ( variables.tmp.device_contacts.length > 0 ) {

						if ( type == 'team' || type == 'internal' ) {

							$container.html( '<li class="anchor contrast" ></li>' );

							$html = '';

							$( variables.tmp.device_contacts ).each( function( i ) {

								console.log( this['device_id'] );

								var ref = Lungo.Core.findByProperty( contacts_, 'device_id', this['device_id'] );

								if ( ref == null ) {

									$html += '<li class="fieldset-blank" style="padding: 0; margin: 0;">';

								} else {

									$html += '<li class="fieldset-blank" style="padding: 0; margin: 0; background: #ccc;" >';

								}

								$html +=		'<fieldset style="margin: 0;" >' +

													'<label class="anchor" style="width: 200px;" >' + this['contact_name'] + '</label>' +

													'<input type="checkbox" name="check-contact-' + ( type == 'team' ? 'team' : 'internal' ) + '-pre" data-rel="tmpl" data-id="' + i + '" class="inline right">' +

												'</fieldset>' +

											'</li>';

							} );

							$container.append( $html );

						} else if ( type == 'side' ) {

							$container.html( '<li class="anchor contrast" ></li>' );

							$html = '';

							$( variables.tmp.device_contacts ).each( function( i ) {

								$html += 	'<li class="filter-devicecontact" onclick="contact.edit_device( \'' + i + '\' )" >' +

												'<a href="#" >' + this['contact_name'] + '</a>' +

											'</li>';

								

							} );

							$container.append( $html );

						}

					} else {

						$container.html( '<li class="anchor contrast" ></li><li><a href="javascript:;" >No results found</a></li>' );						

					}

				}, function() {

					alert( 'error' );

				}, options );

			} else {

				$container.html( '<li class="anchor contrast" ></li><li><a href="javascript:;" >Minimum three (3) characters.</a></li>' );

			}

		} else {

			$container.html( '<li class="anchor contrast" ></li><li><a href="javascript:;" >Feature not available.</a></li>' );

		}				

	},

	render_device_contacts: function() {

		var content = helper.content();

		var content_team = helper.order_contact( content['contact']['team'] );

		var content_internal = helper.order_contact( content['contact']['internal'] );

		var $html_side = '';

		var $html_pre_team = '';

		var $html_pre_internal = '';

		if ( content_team.length > 0 ) {

			$html_pre_team += '<ul style="margin-bottom: 10px;">';

			$( content_team ).each( function() {

				$html_pre_team +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

										'<fieldset style="margin: 0;" >' +

											'<label class="anchor" style="width: 200px;" >' + this['contact_name'] + '</label>' +

											'<input type="checkbox" name="check-contact-team-pre" data-rel="active" checked="checked" data-id="' + this['contact_id'] + '" class="inline right">' +

										'</fieldset>' +

									'</li>';

			} );

			$html_pre_team += '</ul>';

		}

		if ( content_internal.length > 0 ) {

			$html_pre_internal += '<ul style="margin-bottom: 10px;">';

			$( content_internal ).each( function() {

				$html_pre_internal +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

											'<fieldset style="margin: 0;" >' +

												'<label class="anchor" style="width: 200px;" >' + this['contact_name'] + '</label>' +

												'<input type="checkbox" name="check-contact-internal-pre" data-rel="active" checked="checked" data-id="' + this['contact_id'] + '" class="inline right">' +

											'</fieldset>' +

										'</li>';

			} );

			$html_pre_internal += '</ul>';

		}

		$( contact.elements.edit.device_contacts_pre ).html( $html_pre_team );

		$( contact.elements.edit.device_contacts_internal_pre ).html( $html_pre_internal );

	},

	render_default_contacts: function() {

		var $html_side = '';

		var $html_pre = '';

		var content = helper.content();

		var contacts = helper.order_contact( content['contact']['external']['tmp'], true );

		var contacts_active = helper.order_contact( content['contact']['external'], true );

		var rendered_category = false;

		if ( Object.keys( contacts_active ).length > 0 ) {

			$html_pre += '<ul style="margin-bottom: 10px;">';

			for ( var key in contacts_active ) {

				$html_pre += 	'<li class="anchor contrast contact-category" style="margin: 0;" >' + key + '</li>' + 

									'<ul>';

					$( contacts_active[key].data ).each( function() {

						$html_pre +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

											'<fieldset style="margin: 0;" >' +

												'<label class="anchor" style="width: 200px;" >' + this['contact_name'] + '</label>' +

												'<input type="checkbox" name="check-contact-external-pre" data-rel="active" checked="checked" data-id="' + this['contact_id'] + '" class="inline right">' +

											'</fieldset>' +

										'</li>';

					} );

				$html_pre +=	'</ul>';

			}

			$html_pre += '</ul>';

		}

		var render_note = false;

		for ( var key in contacts ) {

			$html_side += 	'<li class="anchor contrast contact-category">' + key + '</li>' + 

							'<ul>';

							//==========

				$( contacts[key].data ).each( function() {

					$html_side +=	'<li onclick="contact.edit_default( \'' + this['contact_id'] + '\' )" >' +

										'<a href="#" >' + this['contact_name'] + '</a>' +

									'</li>';

								//==========

					if ( typeof content['contact']['external'][this['contact_id']] == 'undefined' ) {

						if ( render_note == false ) {

							$html_pre += 	'<ul>' +

												'<li class="light" style="border: none;">' +

													'<span class="small text" style="font-size: 1em;">Choose from the list below or use the <span onclick="contact.add( \'external\' );" class="in-text"></span> icon to add more.</span>' +

												'</li>' +

											'</ul>';

							render_note = true;

						}

						if ( !rendered_category ) {

							$html_pre += 	'<li class="anchor contrast contact-category" style="margin: 0;" >' + key + '</li>' + 

											'<ul>';

							rendered_category = true;

						}

						$html_pre +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

											'<fieldset style="margin: 0;" >' +

												'<label class="anchor" style="width: 200px;" >' + this['contact_name'] + '</label>' +

												'<input type="checkbox" name="check-contact-external-pre" data-rel="tmpl" data-id="' + this['contact_id'] + '" class="inline right">' +

											'</fieldset>' +

										'</li>';

					}

				} );

				if ( rendered_category ) {

					rendered_category = false;

					$html_pre += '</ul>';

				}

			$html_side +=	'</ul>';

			// $html_pre +=	'</ul>';

		}

		$( contact.elements.edit.default_contacts ).html( $html_side );

		$( contact.elements.edit.default_contacts_pre ).html( $html_pre );

	},

	bulk_contact: function() {

		var content = helper.content();

		$( 'input[name="check-contact-internal-pre"][data-rel="tmpl"]:checked' ).each( function( i ) {

			var contact_index = $( this ).attr( 'data-id' );

			var contact_object = variables.tmp.device_contacts[contact_index];

			contact_object['contact_id'] = helper.generate_id();

			contact_object['contact_type'] = 'internal';

			var method = 'insert';

			content['contact']['internal'][contact_object['contact_id']] = contact_object;

			update.update( 'contact', method, contact_object['contact_id'] + '', content['contact']['internal'][contact_object['contact_id']] );

		} );

			$( 'input[name="check-contact-internal-pre"][data-rel="active"]:not(:checked)' ).each( function( i ) {

				var contact_id = $( this ).data( 'id' );

				delete content['contact']['internal'][contact_id];

				update.update( 'contact', 'delete', contact_id + '', {} );

			} );

		$( 'input[name="check-contact-external-pre"][data-rel="tmpl"]:checked' ).each( function( i ) {

			var contact_id = $( this ).data( 'id' );

			var method = 'insert';

			content['contact']['external'][contact_id] = content['contact']['external']['tmp'][contact_id];

			content['contact']['external'][contact_id]['contact_type'] = 'external';

			update.update( 'contact', method, contact_id + '', content['contact']['external'][contact_id] );

		} );

			$( 'input[name="check-contact-external-pre"][data-rel="active"]:not(:checked)' ).each( function( i ) {

				var contact_id = $( this ).data( 'id' );

				delete content['contact']['external'][contact_id];

				update.update( 'contact', 'delete', contact_id + '', {} );

			} );

		helper.content( content );

		contact.render();

		contact.render_device_contacts();

		contact.render_default_contacts();

		setTimeout( function() {

			Lungo.Router.back();

			$( 'input[data-elem="contact-edit-device-internal-pre"]' ).val( '' );

			$( '#' + $( 'input[data-elem="contact-edit-device-internal-pre"]' ).attr( 'data-elem' ) ).empty();

		}, 300 );

	},

	bulk_team: function() {

		var content = helper.content();

		$( 'input[name="check-contact-team-pre"][data-rel="tmpl"]:checked' ).each( function( i ) {

			var contact_index = $( this ).attr( 'data-id' );

			var contact_object = variables.tmp.device_contacts[contact_index];

			contact_object['contact_id'] = helper.generate_id();

			contact_object['contact_type'] = 'team';

			var method = 'insert';

			content['contact']['team'][contact_object['contact_id']] = contact_object;

			update.update( 'contact', method, contact_object['contact_id'] + '', content['contact']['team'][contact_object['contact_id']] );

		} );

			$( 'input[name="check-contact-team-pre"][data-rel="active"]:not(:checked)' ).each( function( i ) {

				var contact_id = $( this ).data( 'id' );

				delete content['contact']['team'][contact_id];

				update.update( 'contact', 'delete', contact_id + '', {} );

			} );

		helper.content( content );

		contact.render();

		contact.render_device_contacts();

		contact.render_default_contacts();

		setTimeout( function() {

			Lungo.Router.back();

			$( 'input[data-elem="contact-edit-device-team-pre"]' ).val( '' );

			$( '#' + $( 'input[data-elem="contact-edit-device-team-pre"]' ).attr( 'data-elem' ) ).empty();

		}, 300 );

	},
	
	edit_device: function( index ) {

		var contact_obj = variables.tmp.device_contacts[index];

		$( contact.elements.edit.tmpl ).removeClass( 'hidden' );

		$( contact.elements.edit.id ).val( '' );

		$( contact.elements.edit.device_id ).val( contact_obj['device_id'] );

		// $( contact.elements.edit.type ).val( 'team' );

		$( contact.elements.edit.name ).val( contact_obj['contact_name'] );

		$( contact.elements.edit.details ).val( contact_obj['contact_details'] );

		$( contact.elements.edit.email ).val( contact_obj['contact_email'] );

		$( contact.elements.edit.number_work ).val( contact_obj['contact_number_work'] );

		$( contact.elements.edit.number_mobile ).val( contact_obj['contact_number_mobile'] );

		$( contact.elements.edit.number_home ).val( contact_obj['contact_number_home'] );

		$( contact.elements.edit.roles ).val( contact_obj['contact_roles'] );

		$( contact.elements.edit.responsibilities ).val( contact_obj['contact_responsibilities'] );

		$( contact.elements.edit.category ).val( 'Access Points' );

		contact.render_roles();

		contact.render_responsibilities();

		Lungo.Router.section( 'contact-edit' );

	},
	
	edit_default: function( contact_id ) {

		var contact_ = helper.content()['contact']['external']['tmp'][contact_id];

		$( contact.elements.edit.tmpl ).removeClass( 'hidden' );

		$( contact.elements.edit.id ).val( '' );

		$( contact.elements.edit.type ).val( 'external' );

		$( contact.elements.edit.hide_template ).removeClass( 'hidden' );

		$( contact.elements.edit.name ).val( contact_['contact_name'] );

		$( contact.elements.edit.details ).val( contact_['contact_details'] );

		$( contact.elements.edit.email ).val( contact_['contact_email'] );

		$( contact.elements.edit.number_work ).val( contact_['contact_number_work'] );

		$( contact.elements.edit.number_mobile ).val( contact_['contact_number_mobile'] );

		$( contact.elements.edit.number_home ).val( contact_['contact_number_home'] );

		$( contact.elements.edit.roles ).val( contact_['contact_roles'] );

		$( contact.elements.edit.responsibilities ).val( contact_['contact_responsibilities'] );

		$( contact.elements.edit.category ).val( contact_['contact_category'] );

		$( contact.elements.edit.team ).addClass( 'hidden' );

		$( contact.elements.edit.external ).removeClass( 'hidden' );

		contact.render_roles();

		contact.render_responsibilities();

		Lungo.Router.section( 'contact-edit' );

	},

	render_responsibilities: function() {

		var checked = $( contact.elements.edit.responsibilities ).val() != '' ? $( contact.elements.edit.responsibilities ).val().split( ',' ) : [];

		var responsibilities = variables.responsibilities.uniqueMerge( checked );

		var data = {

			responsibilities: []

		};

		var $html = '';

		for( var i = 0; i < responsibilities.length; i++ ) {

			if( checked.indexOf( responsibilities[i] ) !== -1 ) {

				data.responsibilities.push( {

					responsibility: responsibilities[i],

					checked: true

				} );

				$html += '<li style="margin: 0;"><label for="responsibilities-' + responsibilities[i] + '" href="#" class="on-right" ><span class="icon remove" ></span></label><strong>' + responsibilities[i] + '</strong></li>'

			} else {

				data.responsibilities.push( {

					responsibility: responsibilities[i],

					checked: false

				} );

			}

		};

		$( '#contact-edit-responsibilities-render' ).html( $html != '' ? $html : '<li data-view-aside="contact-edit-responsibilities-list" >No responsibilities selected</li>' );

		helper.template( $( '#contact-edit-responsibilities-list article' ), $( '#contact-edit-responsibilities-template' ), data );

	},

	render_roles: function() {

		var checked = $( contact.elements.edit.roles ).val() != '' ? $( contact.elements.edit.roles ).val().split( ',' ) : [];

		var roles = variables.roles.uniqueMerge( checked );

		var data = {

			roles: []

		};

		var $html = '';

		for( var i = 0; i < roles.length; i++ ) {

			if( checked.indexOf( roles[i] ) !== -1 ) {

				data.roles.push( {

					role: roles[i],

					checked: true

				} );

				$html += '<li style="margin: 0;"><label for="role-' + roles[i] + '" href="#" class="on-right" ><span class="icon remove" ></span></label><strong>' + roles[i] + '</strong></li>'

			} else {

				data.roles.push( {

					role: roles[i],

					checked: false

				} );

			}

		};

		$( '#contact-edit-roles-render' ).html( $html != '' ? $html : '<li data-view-aside="contact-edit-roles-list" >No roles selected</li>' );

		helper.template( $( '#contact-edit-roles-list article' ), $( '#contact-edit-roles-template' ), data );

	},

	render_responsibilities_view: function() {

		var checked = $( contact.elements.view.responsibilities ).val() != '' ? $( contact.elements.view.responsibilities ).val().split( ',' ) : [];

		var responsibilities = variables.responsibilities.uniqueMerge( checked );

		var data = {

			responsibilities: []

		};

		var $html = '';

		for( var i = 0; i < responsibilities.length; i++ ) {

			if( checked.indexOf( responsibilities[i] ) !== -1 ) {

				data.responsibilities.push( {

					responsibility: responsibilities[i],

					checked: true

				} );

				$html += '<li style="margin: 0;"><label for="responsibilities-view-' + responsibilities[i] + '" href="#" class="on-right" ><span class="icon remove" ></span></label><strong>' + responsibilities[i] + '</strong></li>'

			} else {

				data.responsibilities.push( {

					responsibility: responsibilities[i],

					checked: false

				} );

			}

		};

		$( '#contact-view-responsibilities-render' ).html( $html != '' ? $html : '<li data-view-aside="contact-view-responsibilities-list" >No responsibilities selected</li>' );

		helper.template( $( '#contact-view-responsibilities-list article' ), $( '#contact-view-responsibilities-template' ), data );

	},

	render_roles_view: function() {

		var checked = $( contact.elements.view.roles ).val() != '' ? $( contact.elements.view.roles ).val().split( ',' ) : [];

		var roles = variables.roles.uniqueMerge( checked );

		var data = {

			roles: []

		};

		var $html = '';

		for( var i = 0; i < roles.length; i++ ) {

			if( checked.indexOf( roles[i] ) !== -1 ) {

				data.roles.push( {

					role: roles[i],

					checked: true

				} );

				$html += '<li style="margin: 0;"><label for="role-view-' + roles[i] + '" href="#" class="on-right" ><span class="icon remove" ></span></label><strong>' + roles[i] + '</strong></li>'

			} else {

				data.roles.push( {

					role: roles[i],

					checked: false

				} );

			}

		};

		$( '#contact-view-roles-render' ).html( $html != '' ? $html : '<li data-view-aside="contact-view-roles-list" >No roles selected</li>' );

		helper.template( $( '#contact-view-roles-list article' ), $( '#contact-view-roles-template' ), data );

	}

};