var crisis = {

	elements: {

		active: {

			container: '#home-crisis-active'

		},

		start: {

			container: '#home-crisis-new',

			form: '#home-crisis-start',

			crisis_name: '#crisis-name',

		},

		stop: '#home-crisis-stop'

	},

	is_active: function() {

		var content = helper.content();

		return typeof content['crisis'][0] != 'undefined' ? true : false;

	},

	trigger_crisis: function() {

		if ( crisis.is_active() ) {

			$( crisis.elements.stop ).removeClass( 'hidden' );

			$( crisis.elements.start.container ).addClass( 'hidden' );

			$( crisis.elements.active.container ).removeClass( 'hidden' );

		} else {

			$( crisis.elements.stop ).addClass( 'hidden' );

			$( crisis.elements.active.container ).addClass( 'hidden' );

			$( crisis.elements.start.container ).removeClass( 'hidden' );

		}

	},

	clock: function() {

		var content = helper.content();

		if ( crisis.is_active() ) {

			var elapsed_time = helper.get_date_unix() - Number( content['crisis'][0]['crisis_start_unix'] );

		} else {

			var elapsed_time = 0;

		}

		if ( variables.clock == null ) {

			variables.clock = $( '#clock' ).FlipClock( elapsed_time, {

				autoStart: crisis.is_active(),

				clockFace: 'DailyCounter',

				callbacks: {

					interval: function() {

						var elapsed_time = variables.clock.getTime().time;

						if ( helper.is_minute( elapsed_time ) ) {

							alerts.render_( elapsed_time / 60 );

						}

					}

				}

			} );

		} else if ( variables.clock.getTime() != elapsed_time ) {

			variables.clock.setTime( elapsed_time );

		}

		if ( crisis.is_active() ) {

			if ( !variables.clock.getOption( 'running' ) ) {

				variables.clock.start();

			}

		} else {

			if ( variables.clock.getOption( 'running' ) ) {



			}

		}

		alerts.render_( elapsed_time / 60 );

	},

	start: function() {

		var method = 'insert';

		var request = helper.validate_form( $( crisis.elements.start.form ) );

		if ( request != false ) {

			var content = helper.content();

				content['crisis'][0] = {

					crisis_id: helper.generate_id(),

					crisis_name: $( crisis.elements.start.crisis_name ).val() == '' ? 'Untitled' : $( crisis.elements.start.crisis_name ).val(),

					crisis_start: helper.get_date_format(),

					crisis_start_unix: helper.get_date_unix(),

					crisis_end: 0,

					crisis_end_unix: 0,

					crisis_alert: []

				};

			$( crisis.elements.start.form + ' input' ).val( '' );

			helper.content( content );

			update.update( 'crisis', method, content['crisis'][0]['crisis_id'], content['crisis'][0] );

			crisis.clock();

		}

	},

	stop: function() {

		Lungo.Notification.confirm( {

			icon: 'question-sign',

			title: 'Are you sure you would like to end this crisis?',

			description: 'This <b>cannot</b> be un-done!',

			accept: {

				label: 'Yes',

				icon: 'close',

				callback: function() {

					var method = 'update';

					var data = {

						crisis_end: helper.get_date_format(),

						crisis_end_unix: helper.get_date_unix(),

					};

					var content = helper.content();

					content['crisis'][0]['crisis_end'] = data.crisis_end;

					content['crisis'][0]['crisis_end_unix'] = data.crisis_end_unix;

					var crisis_id = content['crisis'][0]['crisis_id'];

						content['crisis'][crisis_id] = content['crisis'][0]

					delete content['crisis'][0];

					content['log'] = [];

					helper.content( content );

					update.update( 'crisis', method, crisis_id, data );

					variables.clock.setOption( 'running', false );

					variables.clock.reset();

					variables.clock.setTime( 0 );

					crisis.trigger_crisis();

					Lungo.Element.count( '.overdue', 0 );

				}

			},

			cancel: {

				icon: 'close',

				label: 'Cancel',

				callback: function() {

					Lungo.Notification.hide();

				}

			}

		} );

	}

};