var helper = {

	validate_email: function( email ) {

    	var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

    	return re.test( email );

	},

	check: function( selector ) {

		var $checkbox = $( selector );

		variables.checkbox = $checkbox;

		if ( $checkbox.is( ':checked' ) ) {

			// console.log( 'n' );

			$checkbox.removeAttr( 'checked' ).trigger( 'change' );

		} else {

			// console.log( 'y' );

			$checkbox.attr( 'checked', 'checked' ).trigger( 'change' );

		}

	},

	ready_progress: function() {

		var content = helper.content();

		var p = 0;

		if ( Object.keys( content['risk'] ).length != 1 ) {

			p += 25;

		}

		if ( Object.keys( content['pack'] ).length != 1 ) {

			p += 25;

		}

		if ( Object.keys( content['contact']['team'] ).length != 1 ) {

			p += 25;

		}

		if ( Object.keys( content['contact']['internal'] ).length != 1 && Object.keys( content['contact']['external'] ).length != 1 ) {

			p += 25;

		}

		if ( p == 100 ) {

			$( '#ready-msg' ).removeClass( 'hidden' );

		} else {

			$( '#ready-msg' ).addClass( 'hidden' );

		}

		$( '#ready-progress' ).css( 'width', p + '%' );

	},

	keyboard_reset: function( callback ) {

		var callback = typeof callback == 'function' ? callback : function() {};

		setTimeout( function() {

			$( 'input, textarea' ).blur();

			window.scrollTo( 0, 0 );

			callback();

		}, 500 );

	},

	get_crisis_log_count: function( obj, crisis_id ) {

		var count = 0;

		for ( var key in obj ) {

			if ( key != 'tmp' && obj[key]['crisis_id'] == crisis_id ) {

				count++;

			}

		}

		return count;

	},

	get_incomplete_count: function( obj, key_ ) {

		var count = 0;

		for ( var key in obj ) {

			if ( key != 'tmp' && obj[key][key_] == 'false' ) {

				count++;

			}

		}

		return count;

	},

	check_connection: function() {

		if ( in_device ) {

			var network_state = navigator.connection.type;

			var states = {};

				states[Connection.UNKNOWN]  = 'Unknown connection';

				states[Connection.ETHERNET] = 'Ethernet connection';

				states[Connection.WIFI]     = 'WiFi connection';

				states[Connection.CELL_2G]  = 'Cell 2G connection';

				states[Connection.CELL_3G]  = 'Cell 3G connection';

				states[Connection.CELL_4G]  = 'Cell 4G connection';

				states[Connection.CELL]     = 'Cell generic connection';

				states[Connection.NONE]     = 'No network connection';

		}

		var data = {

			connection: in_device ? states[network_state] : 'WiFi connection'

		};

		switch( data.connection ) {

			case 'WiFi connection':
			case 'Ethernet connection':

					data.wifi = true;

				break;

			case 'No network connection':

					data.no_connection = true;

				break;

			default:

					data.mobile_data = true;


		}

		return data;

	},

	get_date_unix: function() {

		return Math.floor( new Date().getTime() / 1000 );

	},

	get_date_format: function() {

		return new Date().format();

	},

	is_minute: function( seconds ) {

		return seconds % 60 === 0;

	},

	alert_status: function( alert_minute, elapsed_time, complete ) {

		return complete ? 'accept' : ( Number( alert_minute ) > Number( elapsed_time ) ? 'color' : 'cancel' );

	},

	alert_icon: function( type ) {

		var icon = 'flag';

		switch ( type ) {

			case 'contact_team':

			case 'contact_internal':

			case 'contact_external':

					icon = 'phone';

				break;

			case 'notification':

					icon = 'flag';

				break;

			case 'camera':

					icon = 'camera';

				break;

		}

		return icon;

	},

	template: function( $elem, $template, data ) {

		var template = Handlebars.compile( $template.html() );

		$elem.html( template( data ) );

		$elem.addClass( 'pre-rendered' );

	},

	ajax: function( url, data, success, error ) {

		$.ajax( {

			type: 'POST',

			url: url,

			data: data,

			success: success,

			error: error

		} );

	},

	validate_form: function( $form ) {

		var is_valid = true,

			error = [],

			obj = {};

		$( 'input', $form ).each( function() {

			var $input = $( this ),

				valid = true;

			obj[$input.attr( 'name' )] = $input.val();

			switch ( $input.data( 'validate' ) ) {

				case 'string':

						if ( $input.data( 'required' ) && $input.val() == '' ) {

							valid = false;

						}

					break;

				case 'email':

						if ( $input.data( 'required' ) && ( $input.val() == '' || !helper.validate_email( $input.val() ) ) ) {

							valid = false;

						}

					break;

				case 'match' :

						if ( $input.data( 'required' ) && ( $input.val() != $( $input.data( 'match' ) ).val() ) ) {

							valid = false;

						}

					break;

			}

			if ( valid ) {

				$input.removeClass( 'border error' );

			} else {

				is_valid = false;

				error.push( $input.data( 'error' ) );

				$input.addClass( 'border error' );

			}

		} );

		if ( is_valid ) {

			return obj;

		} else {

			Lungo.Notification.error( 'Error', error.join( '<br>' ), 'remove' );

			return false;

		}

	},

	validate_input: function( $input ) {

		var valid = true;

		switch ( $input.data( 'validate' ) ) {

			case 'string':

					if ( $input.data( 'required' ) && $input.val() == '' ) {

						valid = false;

					}

				break;

			case 'email':

					if ( $input.data( 'required' ) && ( $input.val() == '' || !helper.validate_email( $input.val() ) ) ) {

						valid = false;

					}

				break;

			case 'match' :

					if ( $input.data( 'required' ) && ( $input.val() != $( $input.data( 'match' ) ).val() ) ) {

						valid = false;

					}

				break;

		}

		if ( valid ) {

			$input.removeClass( 'border error' );

		} else {

			$input.addClass( 'border error' );

		}

	},

	generate_id: function() {

		var content = helper.content();

		return Number( content['user']['user_id'] ) + '' + helper.get_date_unix() + '' + ( Math.floor( Math.random() * 1000 ) + 1 );

	},

	get_dhm: function( minutes ) {

		var seconds = minutes * 60;

		var minutes = Math.floor( seconds / 60 );

		var hours = Math.floor( minutes / 60 );

		var days = Math.floor( hours / 24 );

		return {

			days: days,

			hours: hours - ( days * 24 ),

			minutes: minutes - ( days * 24 * 60 ) - ( ( hours - ( days * 24 ) ) * 60 )

		};

	},

	get_minutes: function( days, hours, minutes ) {

		return ( Number( days ) * 24 * 60 ) + ( Number( hours ) * 60 ) + Number( minutes );

	},

	get_incomplete_count: function( obj, key_ ) {

		var count = 0;

		for ( var key in obj ) {

			if ( key != 'tmp' && obj[key][key_] == 'false' ) {

				count++;

			}

		}

		return count;

	},

	error: function() {

		Lungo.Notification.error( 'An unknown error occured', 'Please try again', 'warning-sign' );

	},

	order_contact: function( contact, render_categories, meta ) {

		var meta = typeof meta != 'undefined' ? meta : 'test';

		var render_categories = typeof render_categories == 'undefined' ? false : render_categories;

		var array = [];

		for ( var key in contact ) {

			if ( [key] != 'tmp' ) {

				array.push( contact[key] );

			}

		}

		if ( render_categories ) {

			Lungo.Core.orderByProperty( array, 'contact_category', 'asc' );

			category_array = {};

			var category = 'null';

			$( array ).each( function() {

				if ( this['contact_category'] != category ) {

					category_array[this['contact_category']] = {

						'category_name': this['contact_category'],

						'data': []

					}

				}

				this['meta'] = meta;

				category_array[this['contact_category']].data.push( this );

				category = this['contact_category'];

			} );

			return category_array;

		} else {

			$( array ).each( function() {

				this['meta'] = meta;

			} );

			return Lungo.Core.orderByProperty( array, 'contact_name', 'asc' );

		}

	},

	order_risk: function( risk, render_categories ) {

		var render_categories = typeof render_categories == 'undefined' ? false : render_categories;

		var array = [];

		for ( var key in risk ) {

			if ( [key] != 'tmp' ) {

				array.push( risk[key] );

			}

		}

		if ( render_categories ) {

			Lungo.Core.orderByProperty( array, 'risk_order', 'asc' );

			category_array = {};

			var category = 'null';

			$( array ).each( function() {

				if ( this['risk_category'] != category ) {

					if ( category != 'null' ) {

						Lungo.Core.orderByProperty( category_array[category].data, 'risk_consequence_order', 'asc' );						

					}

					category_array[this['risk_category']] = {

						'category_name': this['risk_category'],

						'data': []

					}

				}

				category_array[this['risk_category']].data.push( this );

				Lungo.Core.orderByProperty( category_array[this['risk_category']].data, 'risk_name', 'asc' );

				category = this['risk_category'];

			} );

			return category_array;

		} else {

			return Lungo.Core.orderByProperty( array, 'risk_name', 'asc' );

		}

	},

	order_log: function( log, crisis_id ) {

		var render_categories = typeof render_categories == 'undefined' ? false : render_categories;

		var array = [];

		for ( var key in log ) {

			if ( [key] != 'tmp' && log[key]['crisis_id'] == crisis_id ) {

				array.push( log[key] );

			}

		}

		return Lungo.Core.orderByProperty( array, 'log_name', 'asc' );

	},

	order_crisis: function( crisis ) {

		var array = [];

		for ( var key in crisis ) {

			if ( [key] != 'tmp' && [key] != '0' && [key] != 0 ) {

				array.push( crisis[key] );

			}

		}

		return Lungo.Core.orderByProperty( array, 'crisis_start_unix', 'asc' );

	},

	order_alert: function( alert, render_categories ) {

		var array = [];

		for ( var key in alert ) {

			if ( [key] != 'tmp' ) {

				alert[key]['alert_minute'] = Number( alert[key]['alert_minute'] );

				array.push( alert[key] );

			}

		}

		if ( render_categories ) {

			Lungo.Core.orderByProperty( array, 'alert_order', 'asc' );

			category_array = {};

			var category = 'null';

			$( array ).each( function() {

				if ( this['alert_category'] != category ) {

					category_array[this['alert_category']] = {

						'category_name': this['alert_category'],

						'data': []

					}

				}

				category_array[this['alert_category']].data.push( this );

				category = this['alert_category'];

			} );

			return category_array;

		} else {

			return Lungo.Core.orderByProperty( array, 'alert_minute', 'asc' );

		}

	},

	order_pack: function( pack, render_categories ) {

		var render_categories = typeof render_categories == 'undefined' ? false : render_categories;

		var array = [];

		for ( var key in pack ) {

			if ( [key] != 'tmp' ) {

				array.push( pack[key] );

			}

		}

		if ( render_categories ) {

			Lungo.Core.orderByProperty( array, 'pack_category', 'asc' );

			category_array = {};

			var category = 'null';

			$( array ).each( function() {

				if ( this['pack_category'] != category ) {

					if ( category != 'null' ) {

						Lungo.Core.orderByProperty( category_array[category].data, 'pack_name', 'asc' );						

					}

					category_array[this['pack_category']] = {

						'category_name': this['pack_category'],

						'data': []

					}

				}

				category_array[this['pack_category']].data.push( this );

				category = this['pack_category'];

			} );

			return category_array;

		} else {

			return Lungo.Core.orderByProperty( array, 'pack_name', 'asc' );

		}

	},

	order_asset: function( asset, render_categories ) {

		var render_categories = typeof render_categories == 'undefined' ? false : render_categories;

		var array = [];

		for ( var key in asset ) {

			if ( [key] != 'tmp' ) {

				array.push( asset[key] );

			}

		}

		if ( render_categories ) {

			Lungo.Core.orderByProperty( array, 'asset_category', 'asc' );

			category_array = {};

			var category = 'null';

			$( array ).each( function() {

				if ( this['asset_category'] != category ) {

					if ( category != 'null' ) {

						Lungo.Core.orderByProperty( category_array[category].data, 'asset_name', 'asc' );						

					}

					category_array[this['asset_category']] = {

						'category_name': this['asset_category'],

						'data': []

					}

				}

				category_array[this['asset_category']].data.push( this );

				category = this['asset_category'];

			} );

			return category_array;

		} else {

			return Lungo.Core.orderByProperty( array, 'asset_name', 'asc' );

		}

	},

	content: function( obj ) {

		if ( typeof obj == 'object' ) {

			Lungo.Cache.set( 'content', obj );

		}

		return Lungo.Cache.get( 'content' );

	}

};