var init = {

	bind_events: function() {

		Lungo.Events.init( {

			'tap form button': function( e ) {

				e.preventDefault();

				helper.keyboard_reset();

			}

		} );

		if ( in_device ) {

			if ( device.platform.toLowerCase() == 'ios' ) {

				$( document ).delegate( 'textarea, input[type="text"], input[type="email"], input[type="password"], select', 'focus', function() {

					if ( $( '.tmp-overlay' ).length == 0 ) {

						var $overlay = $( '<div class="tmp-overlay" style="display: none;" ></div>' );

						$( 'body' ).append( $overlay.fadeIn( 50 ) );

					}

					trigger_blur = true;

				} );

				$( document ).delegate( 'textarea, input, select', 'blur', function() {

					if ( trigger_blur ) {

						setTimeout( function() {

							var focus = $( 'textarea:focus, input[type="text"]:focus, input[type="email"]:focus, input[type="password"]:focus, select:focus' ).length;

							if ( focus == 0 ) {

								trigger_blur = false;

								$( 'input, textarea, select' ).blur();

								$( '.tmp-overlay' ).fadeOut( 300, function() {

									$( this ).remove();

								} );

							}

						}, 100 );

					}

				} );

				$( document ).delegate( 'body', 'keyup', function( e ) {

					var focus = $( 'textarea:focus' ).length;

					if ( focus === 0 && trigger_blur && e.which === 13 ) {

						trigger_blur = false;

						$( 'input, textarea, select' ).blur();

						$( '.tmp-overlay' ).fadeOut( 300, function() {

							$( this ).remove();

						} );

					}

				} );

				$( document ).delegate( '.tmp-overlay', 'touchend', function() {

					trigger_blur = false;

					setTimeout( function() {

						$( 'input, textarea, select' ).blur();

						$( '.tmp-overlay' ).fadeOut( 300, function() {

							$( this ).remove();

						} );

					}, 100 );

				} );

			}

		}

		$( document ).delegate( 'input[data-required="true"]', 'keyup', function() {

			helper.validate_input( $( this ) );

		} );

		$( document ).delegate( 'input[name="check-contact--roles"]:not([value=""])', 'change', function( e ) {

			$( contact.elements.edit.roles ).val( $('input[name="check-contact--roles"]:checkbox:checked').map( function() { return this.value; } ).get().join( ',' ) );

			contact.render_roles();

		} );

		$( document ).delegate( 'input[name="check-contact--responsibilities"]:not([value=""])', 'change', function( e ) {

			$( contact.elements.edit.responsibilities ).val( $('input[name="check-contact--responsibilities"]:checkbox:checked').map( function() { return this.value; } ).get().join( ',' ) );

			contact.render_responsibilities();

		} );

		//

		$( document ).delegate( 'input[name="check-contact-view-roles"]:not([value=""])', 'change', function( e ) {

			$( contact.elements.view.roles ).val( $('input[name="check-contact-view-roles"]:checkbox:checked').map( function() { return this.value; } ).get().join( ',' ) );

			contact.render_roles_view();

		} );

		$( document ).delegate( 'input[name="check-contact-view-responsibilities"]:not([value=""])', 'change', function( e ) {

			$( contact.elements.view.responsibilities ).val( $('input[name="check-contact-view-responsibilities"]:checkbox:checked').map( function() { return this.value; } ).get().join( ',' ) );

			contact.render_responsibilities_view();

		} );

		$( document ).delegate( '#contact-edit-type', 'change', function() {

			var $select = $( this );

			if ( $select.val() != 'team' ) {

				$( contact.elements.edit.team ).addClass( 'hidden' );

			} else {

				$( contact.elements.edit.team ).removeClass( 'hidden' );

			}

			if ( $select.val() != 'external' ) {

				$( contact.elements.edit.external ).addClass( 'hidden' );

			} else {

				$( '#contact--external' ).show( 0 );

				$( contact.elements.edit.external ).removeClass( 'hidden' );

			}

		} );

		$( document ).delegate( '#alerts-edit-type', 'change', function() {

			var $select = $( this );

			if ( $select.val() != 'contact_team' ) {

				$( alerts.elements.edit.team_extra ).addClass( 'hidden' );

			} else {

				$( alerts.elements.edit.team_extra ).removeClass( 'hidden' );

			}

			if ( $select.val() != 'contact_internal' ) {

				$( alerts.elements.edit.internal_extra ).addClass( 'hidden' );

			} else {

				$( alerts.elements.edit.internal_extra ).removeClass( 'hidden' );

			}

			if ( $select.val() != 'contact_external' ) {

				$( alerts.elements.edit.external_extra ).addClass( 'hidden' );

			} else {

				$( alerts.elements.edit.external_extra ).removeClass( 'hidden' );

			}

		} );

		$( document ).delegate( '#contact-filter', 'change', function() {

			var $select = $( this );

			if( $select.val() == 'all' ) {

				$( '.contact-filter-by' ).show();

			} else {

				$( '.contact-filter-by' ).not( '#contact-' + $select.val() ).hide();

				$( '#contact-' + $select.val() ).show();

			}

		} );

		$( document ).delegate( '#add-input-role, #add-input-responsibility', 'keyup', function() {

			var $this = $( this );

			var $checkbox = $this.siblings( 'input[type="checkbox"]' );

			if ( $this.val().length > 0 ) {

				$checkbox.removeAttr( 'disabled').val( $this.val() );

			} else {

				$checkbox.val( '' ).attr( 'disabled', 'disabled' );

			}

		} );

		$( document ).delegate( '.li-search', 'keyup', function() {

			var $input = $( this );

			var key = $input.data( 'key' );

			if ( $input.val() != '' ) {

				$( '.' + key + '-filter-by li span.text' ).not( '.ignor' ).hide();

			} else {

				$( '.' + key + '-filter-by li span.text' ).show();

			}

			$( '.' + key + '-filter-by li.filter-' + key + '' ).each( function() {

				var $li = $( this );

				// if ( $( 'a', $li ).text().toLowerCase().indexOf( $input.val().toLowerCase() ) != -1 ) {

				if ( $li.text().toLowerCase().indexOf( $input.val().toLowerCase() ) != -1 ) {

					$li.show();

				} else {

					$li.hide();

				}

			} );

			$( '.' + key + '-filter-by' ).each( function() {

				var $ul = $( this );

				var $li = $( 'li.filter-' + key + ':visible', $ul );

				if ( $li.length > 0 ) {

					$( '.empty-list', $ul ).remove();

				} else {

					if ( $( '.empty-list', $ul ).length == 0 ) {

						$ul.append( '<li class="empty-list">No results found</li>' );

					}

				}

				$( '.' + key + '-category', $ul ).each( function() {

					var $category = $( this );

					var $li = $( 'li.filter-' + key + ':visible', $category.next( 'ul' ) );

					if ( $li.length > 0 ) {

						$category.show();

					} else {

						$category.hide();

					}

				} );

			} );

		} );

	},

	init: function() {

		var $elem = $( '#action' );

		switch ( Lungo.Cache.exists( 'content' ) ) {

			case true:

					init.reset();

					$elem.html( '<a class="button" data-view-section="home" >Continue</a>' );

				break;

			case false:

					$elem.html( '<a class="button" data-view-section="authentication" >Login / Register</a>' );

				break;

		}

	},

	reset: function() {

		crisis.clock();

		risk.render();

			risk.render_pre();

		contact.render();

			contact.render_device_contacts();

			contact.render_default_contacts();

		pack.render();

			pack.render_pre();

			pack.render_default_pack();

		alerts.render();

			alerts.render_default_alerts();

		init.comm();

		asset.render();

		log.render();

		review.render();

		sync.init();

		auth.init();

		update.init();

	},

	comm: function() {

		var content = helper.content();

		var user_obj = content['user'];

		var data_ = {

			name: user_obj['user_firstname'] + ' ' + user_obj['user_lastname'],

			trading_name: user_obj['user_tradingname'] == '' ? user_obj['user_companyname'] : user_obj['user_tradingname'],

		};

		var crisis_obj = content['crisis'];

		if ( typeof crisis_obj[0] != 'undefined' ) {

			data_['description'] = crisis_obj[0]['crisis_name']

			data_['date'] = crisis_obj[0]['crisis_start']

		} else {

			data_['description'] = '<b><insert description of incident (eg. a tree has fallen during as a result of Cyclone Suzie and knocked out our power source)></b>';

			data_['date'] = helper.get_date_format()

		}

		helper.template( $( '#comm-templates' ), $( '#comm-template' ), data_ );

	}

};