var log = {

	elements: {

		menu: '#log-menu-icon',

		count: '#log-menu-count',

		article: '#log',

		container: '#log-list',

		active: '#log-active',

		disabled: '#log-disabled',

		msg: '#log-msg',

		edit: {

			trigger: '#log-edit',

			form: '#log-edit-form',

			id: '#log-edit-id',

			name: '#log-edit-name',

			details: '#log-edit-details',

			category: '#log-edit-category',

			state: '#log-edit-state'

		},

		delete: '#log-delete',

		view: {

			id: '#log-view-id',

			name: '#log-view-name',

			details: '#log-view-details',

			state: '#log-view-state'

		}

	},

	init: function() {

		var content = helper.content();

		if ( crisis.is_active() ) {

			var state = helper.get_crisis_log_count( content['log'], content['crisis'][0]['crisis_id'] ) == 0 ? true : false;

		} else {

			var state = false;

		}

		if ( state ) {

			$( log.elements.menu ).removeClass( 'hidden' );

			$( log.elements.msg ).addClass( 'hidden' );

		} else {

			$( log.elements.menu ).addClass( 'hidden' );

			$( log.elements.msg ).removeClass( 'hidden' );

		}

		return state;

	},

	view: function( log_id, router ) {

		var content = helper.content();

		$( log.elements.edit.trigger ).attr( 'onclick', 'log.edit( \'' + log_id + '\' )' );

		$( log.elements.delete ).attr( 'onclick', 'log.delete( \'' + log_id + '\' )' );

		$( log.elements.view.name ).text( content['log'][log_id]['log_name'] );

		$( log.elements.view.details ).html( content['log'][log_id]['log_details'].replace(/\n/g, '<br />') );

		$( log.elements.view.id ).val( log_id );

		if ( typeof router == 'undefined' || router == true ) {

			Lungo.Router.section( 'log-view' );

		}

	},

	add: function() {

		var content = helper.content();

		$( log.elements.edit.id ).val( '' );

		$( log.elements.edit.name ).val( '' );

		$( log.elements.edit.details ).val( '' );

		Lungo.Router.section( 'log-edit' );

	},
	
	edit: function( log_id ) {

		var content = helper.content();

		$( log.elements.edit.id ).val( log_id );

		$( log.elements.edit.name ).val( content['log'][log_id]['log_name'] );

		$( log.elements.edit.details ).val( content['log'][log_id]['log_details'] );

		Lungo.Router.section( 'log-edit' );

	},

	save: function() {

		var content = helper.content();

		var data = {

			log_id: $( log.elements.edit.id ).val() == '' ? helper.generate_id() : $( log.elements.edit.id ).val(),

			crisis_id: content['crisis'][0]['crisis_id'],

			log_name: $( log.elements.edit.name ).val() == '' ? 'Untitled' : $( log.elements.edit.name ).val(),

			log_details: $( log.elements.edit.details ).val(),

			log_entered: helper.get_date_format(),

			log_entered_unix: helper.get_date_unix(),

			log_elapsed: Math.floor( ( helper.get_date_unix() - content['crisis'][0]['crisis_start_unix'] ) / 60 )

		};

		var method = typeof content['log'][data.log_id] == 'undefined' ? 'insert' : 'update';

		content['log'][data.log_id] = data;

		helper.content( content );

		update.update( 'log', method, data.log_id, data );

		log.render();

		Lungo.Router.back();

		log.view( data.log_id, false );

	},
	
	delete: function( log_id ) {

		var content = helper.content();

		delete content['log'][log_id];

		helper.content( content );

		update.update( 'log', 'delete', log_id, {} );

		log.render();

		Lungo.Router.back();

	},

	render: function() {

		var content = helper.content();

		if ( typeof content['crisis'][0] != 'undefined' ) {

			var $log = '';

			var logs = helper.order_log( helper.content()['log'], content['crisis'][0]['crisis_id'] );

			$( logs ).each( function() {

				$log +=		'<li class="arrow filter-log' + ( this['log_state'] == 'false' ? ' cancel' : '' ) + '" onclick="log.view(\'' + this['log_id'] + '\')" >' +

									'<a href="#" >' +

										'<strong>' + this['log_name'] + '</strong>' +

										'<small>' + this['log_details'] + '</small>' +

									'</a>' +

								'</li>';

			} );

			$( log.elements.container ).html( $log );

		} else {



		}

	}

};