var pack = {

	elements: {

		menu: '.menu-icon-pack-incomplete',

		count: '.menu-icon-pack-count',

		article: '#pack',

		container: '#pack-list',

		pre_container: '#pack-pre-list',

		msg: '#pack-msg',

		edit: {

			gopack: '#pack-edit-locations',

			trigger: '#pack-edit',

			add: '#pack-edit-add-tmpl',

			form: '#pack-edit-form',

			id: '#pack-edit-id',

			name: '#pack-edit-name',

			details: '#pack-edit-details',

			category: '#pack-edit-category',

			state: '#pack-edit-state',

			default_pack: '#pack-edit-default',

			documents: '#pack-edit-documents'

		},

		delete: '#pack-delete',

		view: {

			id: '#pack-view-id',

			name: '#pack-view-name',

			details: '#pack-view-details',

			state: '#pack-view-state',

			documents: '#pack-view-documents',

			documents_list: '#pack-view-documents-list'

		}

	},

	init: function() {

		helper.ready_progress();

		var content = helper.content();

		var state = Object.keys( content['pack'] ).length > 1 ? false : true;

		$( pack.elements.count ).addClass( 'hidden' ).text( '' );

		if ( state ) {

			$( pack.elements.menu ).removeClass( 'hidden' );

			$( pack.elements.msg ).addClass( 'hidden' );

		} else {

			var count = helper.get_incomplete_count( content['pack'], 'pack_state' );

			$( pack.elements.menu ).addClass( 'hidden' );

			if ( count === 0 ) {

				$( pack.elements.count ).addClass( 'hidden' ).text( count );

			} else {

				$( pack.elements.count ).removeClass( 'hidden' ).text( count );

			}

			$( pack.elements.msg ).removeClass( 'hidden' );

			state = count;

		}

		return state;

	},

	save_location: function() {

		var data = {

			user_gopack: $( pack.elements.edit.gopack ).val()

		};

		var method = 'update';

		var content = helper.content();

		content['user']['user_gopack'] = data.user_gopack;

		helper.content( content );

		update.update( 'user_app', method, content['user']['user_id'], data );

		Lungo.Notification.show();

		setTimeout( function() {

			Lungo.Notification.hide();

		}, 500 );

	},

	view: function( pack_id, router ) {

		var content = helper.content();

		$( pack.elements.edit.trigger ).attr( 'onclick', 'pack.edit( \'' + pack_id + '\' )' );

		$( pack.elements.delete ).attr( 'onclick', 'pack.delete( \'' + pack_id + '\' )' );

		$( pack.elements.view.name ).text( content['pack'][pack_id]['pack_name'] );

		$( pack.elements.view.details ).html( content['pack'][pack_id]['pack_details'].replace(/\n/g, '<br />') );

		$( pack.elements.view.id ).val( pack_id );

		$( pack.elements.view.documents ).val( content['pack'][pack_id]['pack_documents'] == '' ? [] : content['pack'][pack_id]['pack_documents'] );

		if ( content['pack'][pack_id]['pack_documents'] != '' ) {

			var $html = '';

			var documents = $.parseJSON( content['pack'][pack_id]['pack_documents'] );

			$( documents ).each( function( i ) {

				if ( in_device ) {

					// if ( file.file_exists( this['path'] ) == 'true' ) {

						$html += '<li><a href="#" onclick="pack.remove_document( \'' + this['path'] + '\', this );" class="on-right"><span class="icon remove"></span></a><a href="#" onclick="window.open( \'' + variables.fs.root.fullPath + '/' + this['path'] + '\', \'_blank\', \'EnableViewPortScale=yes,location=yes\' );" >' + this['name'] + '</a></li>';

								// $html += '<li><a href="#" onclick="pack.remove_document( \'' + this['fullPath'] + '\', this );" class="on-right"><span class="icon remove"></span></a><a href="' + this['fullPath'] + '" >' + this['name'] + '</a></li>';

					// } else {

					// 	$html += '<li style="background: #ccc;"><a href="#" onclick="pack.remove_document( \'' + this['path'] + '\', this );" class="on-right"><span class="icon remove"></span></a><a>' + this['name'] + '</a></li>';

					// }

				} else {

					$html += '<li style="background: #ccc;"><a href="#" onclick="pack.remove_document( \'' + this['path'] + '\', this );" class="on-right"><span class="icon remove"></span></a><a>' + this['name'] + '</a></li>';

				}

			} );

			$( pack.elements.view.documents_list ).html( $html );

		} else {

			$( pack.elements.view.documents_list ).html( '' );

		}

		if ( content['pack'][pack_id]['pack_state'] == 'false' ) {

			$( pack.elements.view.state ).removeAttr( 'checked' );

		} else {

			$( pack.elements.view.state ).attr( 'checked', 'checked' );

		}

		if ( typeof router == 'undefined' || router == true ) {

			Lungo.Router.section( 'pack-view' );

		}

	},

	remove_document: function( path, li ) {

		var documents = $.parseJSON( $( pack.elements.view.documents ).val() );

		var new_documents = [];

		$( documents ).each( function() {

			if ( this['path'] != path ) {

				new_documents.push( this );

			}

		} );

		$( pack.elements.view.documents ).val( JSON.stringify( new_documents ) );

		$( li ).closest( 'li' ).css( 'backgroundColor', '#EFA2A6' );

		$( li ).closest( 'li' ).find( 'a' ).css( 'color', '#fff' );

	},

	add: function() {

		var content = helper.content();

		$( pack.elements.edit.add ).removeClass( 'hidden' );

		$( pack.elements.edit.id ).val( '' );

		$( pack.elements.edit.name ).val( '' );

		$( pack.elements.edit.details ).val( '' );

		$( pack.elements.edit.category ).val( 'Documents' );

		$( pack.elements.edit.state ).removeAttr( 'checked' );

		$( pack.elements.edit.documents ).val( '[]' );

		Lungo.Router.section( 'pack-edit' );

	},

	render_default_pack: function() {

		var $html = '';

		var pack_ = helper.order_pack( helper.content()['pack']['tmp'], true );

		for ( var key in pack_ ) {

			$html += 	'<li class="anchor contrast pack-category">' + key + '</li>' + 

							'<ul>';

				$( pack_[key].data ).each( function() {

					$html +=	'<li onclick="pack.edit_default( \'' + this['pack_id'] + '\' )" >' +

									'<a href="#" >' + this['pack_name'] + '</a>' +

								'</li>';

				} );

			$html +=		'</ul>' +

						'</li>';

		}

		$( pack.elements.edit.default_pack ).html( $html );

	},
	
	edit_default: function( pack_id ) {

		var pack_ = helper.content()['pack']['tmp'][pack_id];

		$( pack.elements.edit.add ).removeClass( 'hidden' );

		$( pack.elements.edit.id ).val( '' );

		$( pack.elements.edit.name ).val( pack_['pack_name'] );

		$( pack.elements.edit.details ).val( pack_['pack_details'] );

		$( pack.elements.edit.category ).val( pack_['pack_category'] );

		$( pack.elements.edit.state ).removeAttr( 'checked' );

		$( pack.elements.edit.documents ).val( '[]' );

		Lungo.Router.section( 'pack-edit' );

	},
	
	edit: function( pack_id ) {

		var content = helper.content();

		$( pack.elements.edit.add ).addClass( 'hidden' );

		$( pack.elements.edit.id ).val( pack_id );

		$( pack.elements.edit.name ).val( content['pack'][pack_id]['pack_name'] );

		$( pack.elements.edit.details ).val( content['pack'][pack_id]['pack_details'] );

		$( pack.elements.edit.category ).val( content['pack'][pack_id]['pack_category'] );

		$( pack.elements.edit.documents ).val( content['pack'][pack_id]['pack_documents'] );

		if ( content['pack'][pack_id]['pack_state'] == 'false' ) {

			$( pack.elements.edit.state ).removeAttr( 'checked' );

		} else {

			$( pack.elements.edit.state ).attr( 'checked', 'checked' );

		}

		Lungo.Router.section( 'pack-edit' );

	},

	save: function() {

		var content = helper.content();

		var data = {

			pack_id: $( pack.elements.edit.id ).val() == '' ? helper.generate_id() : $( pack.elements.edit.id ).val(),

			pack_name: $( pack.elements.edit.name ).val() == '' ? 'Untitled' : $( pack.elements.edit.name ).val(),

			pack_details: $( pack.elements.edit.details ).val(),

			pack_category: $( pack.elements.edit.category ).val(),

			pack_state: $( pack.elements.edit.state ).is( ':checked' ) ? 'true' : 'false',

			pack_documents: $( pack.elements.edit.documents ).val()

		};

		var method = typeof content['pack'][data.pack_id] == 'undefined' ? 'insert' : 'update';

		content['pack'][data.pack_id] = data;

		helper.content( content );

		update.update( 'pack', method, data.pack_id, data );

		pack.render();

		pack.render_pre();

		Lungo.Router.back();

		pack.view( data.pack_id, false );

	},

	save_state: function() {

		var method = 'update';

		var content = helper.content();

		var data = {

			pack_id: $( pack.elements.view.id ).val(),

			pack_state: $( pack.elements.view.state ).is( ':checked' ) ? 'true' : 'false',

			pack_documents: $( pack.elements.view.documents ).val()

		};

		content['pack'][data.pack_id]['pack_state'] = data.pack_state;

		content['pack'][data.pack_id]['pack_documents'] = data.pack_documents;

		helper.content( content );

		update.update( 'pack', method, data.pack_id, data );

		pack.render();

		Lungo.Router.back();

		pack.view( data.pack_id, false );

	},
	
	delete: function( pack_id ) {

		var content = helper.content();

		delete content['pack'][pack_id];

		helper.content( content );

		update.update( 'pack', 'delete', pack_id, {} );

		pack.render();

		pack.render_pre();

		Lungo.Router.back();

	},

	bulk: function() {

		var content = helper.content();

		$( 'input[name="check-pack-pre"][data-rel="tmpl"]:checked' ).each( function( i ) {

			var pack_id = $( this ).data( 'id' );

			var method = 'insert';

			content['pack'][pack_id] = content['pack']['tmp'][pack_id];

			update.update( 'pack', method, pack_id + '', content['pack'][pack_id] );

		} );

		$( 'input[name="check-pack-pre"][data-rel="active"]:not(:checked)' ).each( function( i ) {

			var pack_id = $( this ).data( 'id' );

			delete content['pack'][pack_id];

			update.update( 'pack', 'delete', pack_id + '', {} );

		} );

		helper.content( content );

		pack.render();

		pack.render_pre();

		setTimeout( function() {

			Lungo.Router.back();

		}, 300 );

	},

	render: function() {

		pack.init();

		var content = helper.content();

		$( pack.elements.edit.gopack ).val( content['user']['user_gopack'] );

		var $pack = '';

		var packs = helper.order_pack( helper.content()['pack'], true );

		for ( var key in packs ) {

			$pack += 	'<li class="anchor contrast pack-category">' + key + '</li>' + 

							'<ul>';

				$( packs[key].data ).each( function() {

					$pack +=		'<li class="arrow filter-pack' + ( this['pack_state'] == 'false' ? ' cancel' : '' ) + '" onclick="pack.view(\'' + this['pack_id'] + '\')" >' +

										'<a href="#" >' +

											'<strong>' + this['pack_name'] + '</strong>' +

											'<small>' + this['pack_details'] + '</small>' +

										'</a>' +

									'</li>';

				} );

			$pack += 		'</ul>' + 

						'</li>';

		}

		$( pack.elements.container ).html( $pack );

	},

	render_pre: function() {

		var content = helper.content();

		var $pack = '';

		var packs = helper.order_pack( helper.content()['pack'], true );

		if ( Object.keys( packs ).length > 0 ) {

			$pack += '<ul style="margin-bottom: 10px;">';

			for ( var key in packs ) {

				$pack += 	'<li class="anchor contrast pack-category" style="margin:0;">' + key + '</li>' + 

							'<ul>';

					$( packs[key].data ).each( function() {

						$pack +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

										'<fieldset>' +

											'<label class="anchor" style="width: 200px;" >' + this['pack_name'] + '</label>' +

											'<input type="checkbox" name="check-pack-pre" checked data-rel="active" data-id="' + this['pack_id'] + '" class="inline right">' +

										'</fieldset>' +

									'</li>';

					} );

				$pack += 	'</ul>';

			}

			$pack += '</ul>';

		}

		var packs = helper.order_pack( helper.content()['pack']['tmp'], false );

		var render_note = false;

		if ( packs.length > 0 ) {

			$( packs ).each( function() {

				if ( typeof content['pack'][this['pack_id']] == 'undefined' ) {

					if ( render_note == false ) {

						$pack += 	'<ul>' +

										'<li class="light" style="border: none;">' +

											'<span class="small text" style="font-size: 1em;">Choose from the list below or use the <span onclick="pack.add();" class="in-text"></span> icon to add more.</span>' +

										'</li>' +

									'</ul>';

						render_note = true;

					}

					$pack +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

									'<fieldset>' +

										'<label class="anchor" style="width: 200px;" >' + this['pack_name'] + '</label>' +

										'<input type="checkbox" name="check-pack-pre" data-rel="tmpl" data-id="' + this['pack_id'] + '" class="inline right">' +

									'</fieldset>' +

								'</li>';

				}

			} );

		}

		$( pack.elements.pre_container ).html( $pack );

	}

};