var risk = {

	elements: {

		menu: '.menu-icon-risk-incomplete',

		article: '#risk',

		container: '#risk-list',

		pre_container: '#risk-pre-list',

		msg: '.risk-msg',

		edit: {

			trigger: '#risk-edit',

			form: '#risk-edit-form',

			id: '#risk-edit-id',

			name: '#risk-edit-name',

			details: '#risk-edit-details',

			category: '#risk-edit-category',

			consequence: '#risk-edit-consequence'

		},

		delete: '#risk-delete',

		view: {

			name: '#risk-view-name',

			details: '#risk-view-details'

		}

	},

	init: function() {

		helper.ready_progress();

		var state = Object.keys( helper.content()['risk'] ).length > 1 ? false : true;

		if ( state ) {

			$( risk.elements.menu ).removeClass( 'hidden' );

			$( risk.elements.msg ).addClass( 'hidden' );

		} else {

			$( risk.elements.menu ).addClass( 'hidden' );

			$( risk.elements.msg ).removeClass( 'hidden' );

		}

		return state;

	},

	// view: function( risk_id, router ) {

	// 	var content = helper.content();

	// 	$( risk.elements.edit.trigger ).attr( 'onclick', 'risk.edit( \'' + risk_id + '\' )' );

	// 	$( risk.elements.delete ).attr( 'onclick', 'risk.delete( \'' + risk_id + '\' )' );

	// 	$( risk.elements.view.name ).text( content['risk'][risk_id]['risk_name'] );

	// 	$( risk.elements.view.details ).html( content['risk'][risk_id]['risk_details'].replace(/\n/g, '<br />') );

	// 	if ( typeof router == 'undefined' || router == true ) {

	// 		Lungo.Router.section( 'risk-view' );

	// 	}

	// },

	bulk: function() {

		var content = helper.content();

		$( 'input[name="check-risk-pre"][data-rel="tmpl"]:checked' ).each( function( i ) {

			var risk_id = $( this ).data( 'id' );

			var method = 'insert';

			content['risk'][risk_id] = content['risk']['tmp'][risk_id];

			update.update( 'risk', method, risk_id + '', content['risk'][risk_id] );

		} );

		$( 'input[name="check-risk-pre"][data-rel="active"]:not(:checked)' ).each( function( i ) {

			var risk_id = $( this ).data( 'id' );

			delete content['risk'][risk_id];

			update.update( 'risk', 'delete', risk_id + '', {} );

		} );

		helper.content( content );

		risk.render();

		risk.render_pre();

		setTimeout( function() {

			Lungo.Router.back();

		}, 300 );

	},

	add: function() {

		var content = helper.content();

		$( risk.elements.edit.id ).val( '' );

		$( risk.elements.edit.name ).val( '' );

		$( risk.elements.edit.details ).val( '' );

		$( risk.elements.edit.category ).val( 'Likely' );

		$( risk.elements.edit.consequence ).val( 'Medium' );

		Lungo.Router.section( 'risk-edit' );

	},
	
	edit: function( risk_id ) {

		var content = helper.content();

		$( risk.elements.delete ).attr( 'onclick', 'risk.delete( \'' + risk_id + '\' )' );

		$( risk.elements.edit.id ).val( risk_id );

		$( risk.elements.edit.name ).val( content['risk'][risk_id]['risk_name'] );

		$( risk.elements.edit.details ).val( content['risk'][risk_id]['risk_details'] );

		$( risk.elements.edit.category ).val( content['risk'][risk_id]['risk_category'] );

		$( risk.elements.edit.consequence ).val( content['risk'][risk_id]['risk_consequence'] );

		Lungo.Router.section( 'risk-edit' );

	},

	save: function() {

		var content = helper.content();

		var data = {

			risk_id: $( risk.elements.edit.id ).val() == '' ? helper.generate_id() : $( risk.elements.edit.id ).val(),

			risk_name: $( risk.elements.edit.name ).val() == '' ? 'Untitled' : $( risk.elements.edit.name ).val(),

			risk_details: $( risk.elements.edit.details ).val(),

			risk_category: $( risk.elements.edit.category ).val(),

			risk_order: $( risk.elements.edit.category + ' option:selected' ).data( 'order' ),

			risk_consequence: $( risk.elements.edit.consequence ).val(),

			risk_consequence_order: $( risk.elements.edit.consequence + ' option:selected' ).data( 'order' )

		};

		var method = typeof content['risk'][data.risk_id] == 'undefined' ? 'insert' : 'update';

		content['risk'][data.risk_id] = data;

		helper.content( content );

		update.update( 'risk', method, data.risk_id, data );

		risk.render();

		risk.render_pre();

		Lungo.Router.back();

		// risk.view( data.risk_id, false );

	},
	
	delete: function( risk_id ) {

		var content = helper.content();

		delete content['risk'][risk_id];

		helper.content( content );

		update.update( 'risk', 'delete', risk_id, {} );

		risk.render();

		risk.render_pre();

		Lungo.Router.back();

	},

	render: function() {

		var content = helper.content();

		risk.init();

		var $risk = '';

		var risks = helper.order_risk( helper.content()['risk'], true );

		for ( var key in risks ) {

			$risk += 	'<li class="anchor contrast risk-category">' + key + '</li>' + 

							'<ul>';

				$( risks[key].data ).each( function() {

					$risk +=		'<li class="arrow filter-risk ' + risk.consequence_color( this['risk_consequence'] ) + '" onclick="risk.edit(\'' + this['risk_id'] + '\')" >' +

										'<a href="#" >' +

											'<strong>' + this['risk_name'] + '</strong>' +

											'<small>' + this['risk_details'] + '</small>' +

										'</a>' +

									'</li>';

				} );

			$risk += 		'</ul>' + 

						'</li>';

		}

		$( risk.elements.container ).html( $risk );

	},

	consequence_color: function( consequence ) {

		var cons = '';

		switch ( consequence ) {

			case 'Extreme':

					cons = 'one';

				break;

			case 'Very high':

					cons = 'two';

				break;

			case 'Medium':

					cons = 'three';

				break;

			case 'Low':

					cons = 'four';

				break;

		}

		return 'cons-' + cons;

	},

	render_pre: function() {

		var content = helper.content();

		var $risk = '';

		var risks = helper.order_risk( helper.content()['risk'], true );

		if ( Object.keys( risks ).length > 0 ) {

			$risk += '<ul style="margin-bottom: 10px;">';

			for ( var key in risks ) {

				$risk += 	'<li class="anchor contrast risk-category" style="margin:0;">' + key + '</li>' + 

							'<ul>';

					$( risks[key].data ).each( function() {

						$risk +=	'<li class="fieldset-blank ' + risk.consequence_color( this['risk_consequence'] ) + '" style="padding: 0; margin: 0;">' +

										'<fieldset >' +

											'<label class="anchor" style="width: 200px;" >' + this['risk_name'] + '</label>' +

											'<input type="checkbox" name="check-risk-pre" checked data-rel="active" data-id="' + this['risk_id'] + '" class="inline right">' +

										'</fieldset>' +

									'</li>';

					} );

				$risk += 	'</ul>';

			}

			$risk += '</ul>';

		}

		var risks = helper.order_risk( helper.content()['risk']['tmp'], false );

		var render_note = false;

		if ( risks.length > 0 ) {

			$( risks ).each( function() {

				if ( typeof content['risk'][this['risk_id']] == 'undefined' ) {

					if ( render_note == false ) {

						$risk += 	'<ul>' +

										'<li class="light" style="border: none;">' +

											'<span class="small text" style="font-size: 1em;">Choose from the list below or use the <span onclick="risk.add();" class="in-text"></span> icon to add more.</span>' +

										'</li>' +

									'</ul>';

						render_note = true;

					}

					$risk +=	'<li class="fieldset-blank" style="padding: 0; margin: 0;">' +

									'<fieldset>' +

										'<label class="anchor" style="width: 200px;" >' + this['risk_name'] + '</label>' +

										'<input type="checkbox" name="check-risk-pre" data-rel="tmpl" data-id="' + this['risk_id'] + '" class="inline right">' +

									'</fieldset>' +

								'</li>';

				}

			} );

		}

		$( risk.elements.pre_container ).html( $risk );

	}

};