var sync = {

	elements: {

		landing: {

			type: '#sync-landing-connection',

			wifi: '#sync-landing-wifi',

			mobile_data: '#sync-landing-mobiledata',

			no_connection: '#sync-landing-noconnection'

		}

	},

	init: function() {

		var data = helper.check_connection();

		$( sync.elements.landing.type ).text( data.connection );

		if ( data.wifi ) { $( sync.elements.landing.wifi ).removeClass( 'hidden' ); } else { $( sync.elements.landing.wifi ).addClass( 'hidden' ); }

		if ( data.mobile_data ) { $( sync.elements.landing.mobile_data ).removeClass( 'hidden' ); } else { $( sync.elements.landing.mobile_data ).addClass( 'hidden' ); }

		if ( data.no_connection ) { $( sync.elements.landing.no_connection ).removeClass( 'hidden' ); } else { $( sync.elements.landing.no_connection ).addClass( 'hidden' ); }

	},

	sync: function() {

		Lungo.Notification.show();

		if ( in_device ) {

			sync.sync_device();

		} else {

			sync.sync_desktop();

		}

	},

	sync_device: function() {

		var env = Lungo.Core.environment();

		var content = helper.content();

		var ft = new FileTransfer(),

			path = variables.fe['update'].fullPath,

			name = variables.fe['update'].name;

		ft.upload( path, variables.request_sync, function( result ) {

			variables.test = result;

			try {

				var response_obj = $.parseJSON( atob( result.response ) );

				switch( response_obj.response ) {

					case '0':

							sync.save( response_obj );

							Lungo.Router.back();

							Lungo.Notification.success( 'Sync successful', '', 'ok', 2, function() {

								Lungo.Notification.hide();

							} );

						break;

					default:

						helper.error();

				}

			} catch( e ) {

				helper.error();

			}

		}, function( error ) {

			// helper.error();

			Lungo.Notification.confirm( {

				icon: 'question-sign',

				title: 'An unknown error occured',

				description: 'Please try again, if this error persists force an update ( You may loose unsaved changes )',

				accept: {

					label: 'Force update',

					callback: function() {

						setTimeout( function() {

							Lungo.Notification.show();

							helper.ajax( variables.request_sync, {

								'user_emailaddress': content['user']['user_emailaddress'],

								'user_password': content['user']['user_password_enc'],

								'encrypted': 'true',

								'local_datetime': helper.get_date_format(),

								'device': env['os'] == null ? 'Desktop' : env['os'].name,

								'data': btoa( '{"data":[]}' ),

								'file_upload': 'false'

							}, function( response_json ) {

								try {

									var response_obj = $.parseJSON( atob( response_json ) );

									switch( response_obj.response ) {

										case '0':

												sync.save( response_obj );

												Lungo.Router.back();

												Lungo.Notification.success( 'Sync successful', '', 'ok', 2, function() {

													Lungo.Notification.hide();

												} );

											break;

										default:

											helper.error();

									}

								} catch( e ) {

									helper.error();

								}

							}, function() {

								helper.error();

							} );

						}, 500 );

					}

				},

				cancel: {

					label: 'Close',

					callback: function() {

						Lungo.Notification.hide();

					}
				}

			} );
		
		}, { params: {

			'user_emailaddress': content['user']['user_emailaddress'],

			'user_password': content['user']['user_password_enc'],

			'encrypted': 'true',

			'local_datetime': helper.get_date_format(),

			'device': env['os'] == null ? 'Desktop' : env['os'].name,

			'file_upload': 'true'

		} } );

	},

	sync_desktop: function() {

		var env = Lungo.Core.environment();

		var content = helper.content();

		helper.ajax( variables.request_sync, {

			'user_emailaddress': content['user']['user_emailaddress'],

			'user_password': content['user']['user_password_enc'],

			'encrypted': 'true',

			'local_datetime': helper.get_date_format(),

			'device': env['os'] == null ? 'Desktop' : env['os'].name,

			'data': btoa( JSON.stringify( Lungo.Cache.get( 'update' ) ) ),

			'file_upload': 'false'

		}, function( response_json ) {

			try {

				var response_obj = $.parseJSON( atob( response_json ) );

				switch( response_obj.response ) {

					case '0':

							sync.save( response_obj );

							Lungo.Router.back();

							Lungo.Notification.success( 'Sync successful', '', 'ok', 2, function() {

								Lungo.Notification.hide();

							} );

						break;

					default:

						helper.error();

				}

			} catch( e ) {

				helper.error();

			}

		}, function() {

			// helper.error();

			Lungo.Notification.confirm( {

				icon: 'question-sign',

				title: 'An unknown error occured',

				description: 'Please try again, if this error persists force an update ( You may loose unsaved changes )',

				accept: {

					label: 'Force update',

					callback: function() {

						setTimeout( function() {

							Lungo.Notification.show();

							helper.ajax( variables.request_sync, {

								'user_emailaddress': content['user']['user_emailaddress'],

								'user_password': content['user']['user_password_enc'],

								'encrypted': 'true',

								'local_datetime': helper.get_date_format(),

								'device': env['os'] == null ? 'Desktop' : env['os'].name,

								'data': btoa( '{"data":[]}' ),

								'file_upload': 'false'

							}, function( response_json ) {

								try {

									var response_obj = $.parseJSON( atob( response_json ) );

									switch( response_obj.response ) {

										case '0':

												sync.save( response_obj );

												Lungo.Router.back();

												Lungo.Notification.success( 'Sync successful', '', 'ok', 2, function() {

													Lungo.Notification.hide();

												} );

											break;

										default:

											helper.error();

									}

								} catch( e ) {

									helper.error();

								}

							}, function() {

								helper.error();

							} );

						}, 500 );

					}

				},

				cancel: {

					label: 'Close',

					callback: function() {

						Lungo.Notification.hide();

					}
				}

			} );

		} );

	},

	save: function( data ) {

		Lungo.Cache.set( 'content', data.content );

		Lungo.Cache.set( 'update', data.update );

		init.reset();

		if ( in_device ) {

			file.save( data );

		}

	}

};